'gbSearch by Gary Beene, 2011
#Compile Exe "gbSearch"
#Dim All

#Include "Win32API.inc"
#Include "richedit.inc"
#Include "CommCtrl.inc"

Declare Function PATHMATCHSPEC Lib "SHLWAPI.DLL" Alias "PathMatchSpecA" ( pszFile As AsciiZ, pszSpec As AsciiZ ) As Long
Declare Function TzSpecificLocalTimeToSystemTime Lib "Kernel32.dll" _
    Alias "TzSpecificLocalTimeToSystemTime" _
    (lpTimeZoneInformation As TIME_ZONE_INFORMATION, _
    lpLocalTime As SYSTEMTIME, lpUniversalTime As SYSTEMTIME) As Long

#Resource "gbsearch.pbr"
$ver = "  gbSearch v1.12"

Type PolyPoints           'used in drawing the chevrons to the left of the RichEdit Control
  count As Long
  x1 As Single
  y1 As Single
  x2 As Single
  y2 As Single
  x3 As Single
  y3 As Single
End Type

Type INIData
  status As Long
  path As String * %Max_Path
  date As String * 25
  size As String * 15
  ext  As String * 20
End Type

Type CustomColors
   c(15) As Long
End Type

%ID_Timer         = 300
%IDC_ComboTerms   = 400
%IDC_ComboFolders = 401
%IDC_Toolbar      = 402
%IDC_ListView     = 403
%IDC_LabelTerm    = 404
%IDC_LabelFolder  = 405
%IDC_RichEdit     = 406
%IDC_LabelFilter  = 407
%IDC_ComboFilters = 408
%IDC_LabelV       = 409
%IDC_TreeView     = 410
%IDC_Graphic      = 411
%IDC_StatusBar    = 412
%IDC_Calendar     = 413

%IDT_Search       = 501
%IDT_MergeFiles   = 502
%IDT_SelectFolder = 503
%IDT_CheckBas     = 504
%IDT_CheckInc     = 505
%IDT_CheckTxt     = 506
%IDT_ExactCaseMatch  = 507
%IDT_SubFolders   = 508
%IDT_Help         = 509
%IDT_Terms        = 510
%IDT_CheckList    = 511
%IDT_ViewFile     = 512
%IDT_ViewTree     = 513
%IDT_Settings     = 514
%IDT_Undo         = 515
%IDT_CheckAll     = 516
%IDT_Date         = 517
%IDT_Size         = 518   'button on toolbar - buttons must be sequential equates

%IDM_Sep             = 602
%IDM_ToggleDebug     = 603
%IDM_ClearConsole    = 604
%IDM_EditExt         = 605
%IDM_CopyList        = 606
%IDM_CheckAll        = 607
%IDM_UnCheckAll      = 608
%IDM_FindNext        = 609
%IDM_FindPrevious    = 610
%IDM_CopyAll         = 611
%IDM_FindFirst       = 612
%IDM_RESummary       = 613
%IDM_RemoveAllResults= 614
%IDM_RemoveChecked   = 615
%IDM_RemoveUnChecked = 616
%IDM_SetBaseFolder   = 617
%IDM_OpenFolder      = 618
%IDM_CheckDuplicates = 619
%IDM_CopyChecked     = 620
%IDM_ClearWorking    = 621
%IDM_OpenWorking     = 622
%IDM_Options         = 623
%IDM_Dividers        = 624
%IDM_ToolbarText     = 625
%IDM_ExactFileSize   = 626
%IDM_Compare         = 627
%IDM_AutoSizeToWidth = 628
%IDM_DisplaySummary  = 629
%IDM_NextDivider     = 630
%IDM_OpenExternally  = 631
%IDM_OpenAllDefault  = 632
%IDM_hCommand        = 633
%IDM_OpenCheckedSpecified= 634
%IDM_SpecifyClient   = 635
%IDM_HighlightTerms  = 636
%IDM_UNHighlightTerms= 637
%IDM_DeleteSelected  = 638
%IDM_DeleteChecked   = 639
%IDM_RemoveSelected  = 640
%IDM_ReverseChecks   = 641
%IDM_MatchingLinesOnly = 642
%IDM_AutoOpenMerge   = 643
%IDM_OpenMergeFile   = 644
%IDM_ReloadMergeFile = 645
%IDM_OpenSelSpecified= 646
%IDM_RemoveComments  = 647
%IDM_RemoveSplits    = 648
%IDM_SortContentA    = 649
%IDM_SortContentD    = 650
%IDM_RemoveFType     = 651
%IDM_LineNumbers     = 652
%IDM_AddLineNumbers  = 653
%IDM_RemoveLineNumbers  = 654
%IDM_RemoveDividers     = 655
%IDM_RemoveBlankLines   = 656

%IDM_PreviousDivider = 658
%IDM_HiddenSystem    = 659
%IDM_AutoSizeToData  = 660
%IDM_AutoSizeToNone  = 661
%IDM_Date            = 662
%IDM_Size            = 663
%IDM_Unrestricted    = 664
%IDM_OpenDivider     = 665
%IDM_ColoredLines    = 666
%IDM_LineColor       = 667
%IDM_ExportCSV       = 668
%IDM_ExportTXT       = 669
%IDM_ExportTXTB      = 670
%IDM_AllowFileDeletion = 671
%IDM_ImpliedSearch   = 672

%IDM_UpperCase       = 700
%IDM_LowerCase       = 701
%IDM_TrimBoth        = 702
%IDM_TrimLeft        = 703
%IDM_TrimRight       = 704
%IDM_Delete1Col      = 705
%IDM_Delete4Col      = 706
%IDM_Insert1Col      = 707
%IDM_Insert4Col      = 708
%IDM_RemoveDupeLines = 709
%IDM_RemoveSpaces    = 710
%IDM_WordList        = 711

%IDM_PBCodec         = 750
%IDM_PBProcList      = 751

%IDM_Drive           = 1000
%IDM_ExtList         = 2000
%IDM_gbSnippets      = 3000

%IDM_FolderCut     = 801
%IDM_FolderCopy    = 802
%IDM_FolderPaste   = 803
%IDM_FolderDelete  = 804
%IDM_FolderOpen    = 805
%IDM_FolderUpOne   = 806
%IDM_FolderClear   = 807

%IDM_TermsCut      = 808
%IDM_TermsCopy     = 809
%IDM_TermsPaste    = 810
%IDM_TermsDelete   = 811
%IDM_TermsClear    = 812

%IDM_FiltersCut    = 813
%IDM_FiltersCopy   = 814
%IDM_FiltersPaste  = 815
%IDM_FiltersDelete = 816
%IDM_FiltersClear  = 817

%IDM_RichEditCut   = 818
%IDM_RichEditCopy  = 819
%IDM_RichEditPaste = 820
%IDM_RichEditDelete= 821
%IDM_RichEditSave  = 822
%IDM_RichEditSaveAs= 823
%IDM_FilterOpen    = 824

%IDM_All           = 900
%IDM_Any           = 901
%IDM_Exact         = 902
%IDM_SubFolders    = 903
%IDM_MatchCase     = 904
%IDM_DateFrom      = 905
%IDM_DateTo        = 906
%IDM_SizeFrom      = 907
%IDM_SizeTo        = 908
%IDM_ResetDates    = 909

%COST_ADD1 = 1
%COST_ADD2 = 1
%COST_REPL = 1

%move_NoChange = 0
%move_Replace = 1
%move_Add1 = 2
%move_Add2 = 3

%AllTerms    = 1
%AnyTerms    = 2
%ExactString = 3

%AutoSizeToNone   = 0   'do not autosize
%AutoSizeToWidth  = 1   'fit columns to width of dialog
%AutoSizeToData   = 2   'size column to fit data content

'control/menu handles
Global hDlg, hCal, hToolbar, hCalendar, hImageList, hListView, hComboTerms As Dword
Global hComboFilters,hTerms, hExtList,hMerge,hSettings,hDate,hSize As Dword
Global hContextFolders, hContextTerms, hContextFilters,hTooltip,hHook As Dword
Global hComboFoldersEdit, hComboTermsEdit, hComboFiltersEdit, hDriveList As Dword
Global hComboFolders, hContextListView, hContextViewer, hConsole, hRichEdit As Dword
'toolbar selections
Global iAll, iBas, iInc, iTxt, iList, ExactCaseMatch, SearchMethod, SubFolders As Long
'options
Global Unrestricted, HiddenSystem, LineNumbers, Dividers, ToolbarText, ExactFileSize As Long
Global ColoredLines, LineColor, UseSearchTerms, UseDateRange, UseSizeRange, AutoSize, ImpliedSearch As Long
'restore session
Global FileFilter, SpecifiedClient, Drive, SelectedFile,UndoText, BadChar, GoodChar, CustomDivider, TxtDivider As String
Global sTerm, sFolder, T(), folderMRU(), filterMRU(), stermMRU(), FileSpec As String
Global ViewFile, ViewTree, MaxMRUFolders, MaxMRUFilters, MaxMRUTerms, Debug As Long
Global SortDirection, FileCount, FolderCount As Long
Global ColName, ColPath, ColDate, ColSize, ColExt, LVActive, ChevronColor As Long
Global AutoOpenMerge, ViewingMergeFile, LVRefreshInWork, OneOnly, Startup As Long
Global SizeFrom, SizeTo, AllowFileDeletion As Long
Global DateFrom, DateTo As FileTime, DateFromS, DateToS, TextExt, ImageExt As String
Global Files(),Folders() As DirData, DT As SystemTime
Global CustomColorList As CustomColors
Global qFreq, qStart,qStop As Quad
'subclassing
Global OldComboFiltersEditProc&, OldComboTermsEditProc&, OldComboFoldersEditProc&
Global xfolders,yfolders,xterms,yterms As Long
'splitter bar
Global SplitVInWork,VBarTop As Long

Function PBMain() As Long
   Local style&
   style& = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or %ES_AutoHScroll _
            Or %WS_HScroll Or %ES_AutoVScroll Or %ES_WantReturn Or %WS_TabStop Or %ES_SaveSel Or %ES_NoHideSel

   Dialog New Pixels, 0, $Ver,300,300,670,400, %WS_OverlappedWindow Or %WS_ClipChildren To hDlg
   Dialog Set Icon hDlg, "a"
   Control Add Label, hDlg, %IDC_LabelFolder,"Base Folder:", 10,60,70,20, %SS_Notify
   Control Add Label, hDlg, %IDC_LabelFilter, "Name Filter:", 10,90,70,20, %SS_Notify
   Control Add Label, hDlg, %IDC_LabelTerm,"Search Term(s):", 190,90,75,20

   Control Add ComboBox, hDlg, %IDC_ComboFolders,folderMRU(),80,60,580,120
   Control Handle hDlg, %IDC_ComboFolders To hComboFolders

   Control Add ComboBox, hDlg, %IDC_ComboFilters, filterMRU(), 80,90,100,120  ', %WS_TabStop Or %WS_Border Or %ES_Center Or %ES_AutoHScroll
   Control Handle hDlg, %IDC_ComboFilters To hComboFilters

   Control Add ComboBox, hDlg, %IDC_ComboTerms,stermMRU(),280,90,200,120
   Control Handle hDlg, %IDC_ComboTerms To hComboTerms

   Control Add "SysMonthCal32", hDlg, %IDC_Calendar, "", -200,-200, 180,160, %WS_Child Or %WS_Visible
   Control Handle hDlg, %IDC_Calendar To hCalendar

   Control Add ListView, hDlg, %IDC_ListView,"", 10,120,960,100, %WS_TabStop Or %LVS_Report Or %LVS_ShowSelAlways Or %LVS_SingleSel Or %WS_Border
   Control Handle hDlg, %IDC_ListView To hListView
   ListView Set StyleXX hDlg, %IDC_ListView, %LVS_Ex_CheckBoxes Or %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect Or %LVS_Ex_DoubleBuffer
   ListView Insert Column hDlg, %IDC_ListView, 1, "File Name", 200, 0
   ListView Insert Column hDlg, %IDC_ListView, 2, "Full Path", 500, 0
   ListView Insert Column hDlg, %IDC_ListView, 3, "Date", 120, 0
   ListView Insert Column hDlg, %IDC_ListView, 4, "KB", 120, 1
   ListView Insert Column hDlg, %IDC_ListView, 5, "Ext", 100, 0

   Control Add Treeview, hDlg, %IDC_TreeView, "",  10, 60, 200, 300, %TVS_TrackSelect Or %TVS_HasLines Or %TVS_HasButtons Or %TVS_LinesAtRoot _
       Or %TVS_ShowSelAlways Or %WS_TabStop, %WS_Ex_ClientEdge Or %WS_Ex_Left 'Or %WS_Ex_AcceptFiles

   Control Add Label, hDlg, %IDC_LabelV, "",  0,200, 600, 6, %SS_Notify , %WS_Ex_ClientEdge   ' left/right - does vertical split
   Control Set Color hDlg, %IDC_LabelV, %rgb_LightBlue, %rgb_LightBlue

   LoadLibrary("riched32.dll")
   InitCommonControls
   Control Add "RichEdit", hDlg, %IDC_RichEdit, "",10,240,640,100, style&, %WS_Ex_ClientEdge
   Control Handle hDlg, %IDC_RichEdit To hRichEdit
   SendMessage hRichEdit, %EM_SETEVENTMASK, 0, %ENM_SELCHANGE Or %ENM_CHANGE Or %ENM_Scroll Or %ENM_LINK Or %ENM_KeyEvents
   SendMessage hRichEdit, %EM_ExLIMITTEXT, 1000000, 0     'raise to 5M limit

   Control Add Graphic, hDlg, %IDC_Graphic, "", 0,250,10,60,%SS_Notify
   hToolTip = CreateWindowEx(ByVal 0, "tooltips_class32", "", %TTS_ALWAYSTIP,  _
              0, 0, 0, 0, ByVal hDlg, ByVal 0, GetModuleHandle(ByVal %NULL), ByVal 0)
   SetTooltip(GetDlgItem(hDlg, %IDC_Graphic), "Previous Match . Next Match . Highlight Terms . Matching Lines")
   Graphic Attach hDlg, %IDC_Graphic

   BuildExtensionsList
   BuildAcceleratorTable
   CreateImageList
   CreateContextMenus
   CreateToolbarContextMenu
   SubClassControls

   Control Add Statusbar, hDlg, %IDC_StatusBar,"",0,0,0,0, %CCS_Bottom Or %SBars_SizeGrip
   Statusbar Set Parts hDlg, %IDC_StatusBar,200,99999
   Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, ""

   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local i,x,y,iResult As Long, temp$, nmtb As TBNOTIFY Ptr, rc As RECT, pt As PointAPI, CR As CharRange
   Local P As TOOLTIPTEXT Ptr, LVData As NM_ListView, hItem As Dword, tempz As AsciiZ * %Max_Path
   Local lplvcd As NMLVCUSTOMDRAW Ptr
   Select Case Cb.Msg
      Case %WM_InitDialog
         QueryPerformanceFrequency qFreq
         Startup = 1
         Settings_INI "get"
         If IsFolder (Exe.Path$ + "working") = %False Then MkDir Exe.Path$ + "working\"
         UpdateTextExt
         CreateToolbar
         AdjustControlPositions
         If Debug Then cPrint "Console Display Enabled" + $CrLf + String$(30,"=")
         ReDim Files(350000), Folders(50000)      'should be enough folder for almost any PC?
         If Len(Trim$(Command$)) Then
             If IsFolder(Command$) Then sFolder = Command$ : AddToFolderMRU
             If IsFile(Command$) Then sFolder = PathName$(Path,Command$) : AddToFolderMRU
         End If
         LoadFoldersComboBox : LoadSearchTermsComboBox : LoadFileFiltersComboBox
         Treeview Insert Item hDlg, %IDC_TreeView, 0, %TVI_Last, 1,1,Drive To hItem
         DisplayChildren hItem
         Treeview Set Expanded hDlg, %IDC_TreeView, hItem, %True
         If Len(SelectedFile) Then SelectFile
         If ViewingMergeFile Then
             ReloadMergeFile
         ElseIf ViewFile And Len(Dir$(SelectedFile)) Then
             LoadSelectedFile
         End If
         Control Set Focus hDlg, %IDC_ComboTerms
         PostMessage GetDlgItem(hDlg, %IDC_ComboFolders), %CB_SeteditSel, 0, Mak(Long,-1,0)
         Startup = 0
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDT_SelectFolder
                SelectFolder
                AddToFolderMRU
                LoadFoldersComboBox
            Case %IDM_Drive To %IDM_Drive + 26
                If ViewTree = 0 Then ViewTree = 1 : AdjustControlPositions : ResizeWindow
                Treeview Reset hDlg, %IDC_TreeView
                Menu Get Text hDriveList, ByCmd Cb.Ctl To temp$
                Drive = LCase$(temp$)
                Treeview Insert Item hDlg, %IDC_TreeView, 0, %TVI_Last, 1,1,Drive To hItem
                DisplayChildren hItem
                Treeview Set Expanded hDlg, %IDC_TreeView, hItem, %True
            Case %IDT_Search       : Search : ResizeWindow : SetUndo("",0)  '1 - results are all file containing search term
            Case %IDT_MergeFiles
                Control Set Text hDlg, %IDC_RichEdit, ""             'removes highlighting, if it exists
                CreateMergeFile : SetUndo("",0)
                Control Set Focus hDlg, %IDC_RichEdit
            Case %IDM_gbSnippets
                Control Get Text hDlg, %IDC_RichEdit To temp$
                SetUndo(temp$,1)
                ListView Sort hDlg, %IDC_ListView, 2, Ascend, UCase
                CreateGBSFile
            Case %IDT_Undo
                Control Set Text hDlg, %IDC_RichEdit, ""             'removes highlighting if it exists
                Control Set Text hDlg, %IDC_RichEdit, UndoText : SetUndo("",0)

            Case %IDT_ViewTree     : ViewTree = ViewTree Xor 1 : AdjustControlPositions : Control ReDraw hDlg, %IDC_Listview : : ResizeWindow
            Case %IDT_ViewFile     : ViewFile = ViewFile Xor 1 : DisplayFileViewer : ResizeWindow

            Case %IDT_CheckAll     : iAll = iAll Xor 1
            Case %IDT_CheckBas     : iBas = iBas Xor 1
            Case %IDT_CheckInc     : iInc = iInc Xor 1
            Case %IDT_CheckTxt     : iTxt = iTxt Xor 1
            Case %IDT_CheckList    : iList = iList Xor 1
            Case %IDM_ExtList
                temp$ = Exe.Path$ + "extensions.txt"
                iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

            Case %IDM_All          : SearchMethod = %AllTerms              : SetToolbarMenuStatus
            Case %IDM_Any          : SearchMethod = %AnyTerms              : SetToolbarMenuStatus
            Case %IDM_Exact        : SearchMethod = %ExactString           : SetToolbarMenuStatus

            Case %IDT_Terms, %IDM_Date : UseSearchTerms = UseSearchTerms Xor 1 : SetToolbarmenuStatus
            Case %IDT_Date,  %IDM_Date : UseDateRange   = UseDateRange Xor 1   : SetToolbarmenuStatus
            Case %IDT_Size,  %IDM_Size : UseSizeRange   = UseSizeRange Xor 1   : SetToolbarMenuStatus

            Case %IDT_SubFolders, %IDM_SubFolders    : SubFolders = SubFolders Xor 1         : SetToolbarMenuStatus
            Case %IDT_ExactCaseMatch, %IDM_MatchCase : ExactCaseMatch = ExactCaseMatch Xor 1 : SetToolbarMenuStatus

            Case %IDT_Help
               temp$ = "http://www.garybeene.com/sw/gbsearch.htm"
               iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

            Case %IDC_Graphic
               Select Case Cb.CtlMsg
                   Case %STN_Clicked, %STN_DblClk
                      GetCursorPos pt                                    'pt has xy screen coordinates
                      ScreenToClient GetDlgItem(hDlg,%IDC_Graphic), pt   'pt now has dialog client coordinates
                      If pt.y < 13 Then
                         ChevronColor = 1
                         DrawChevron
                         Control Set Focus hDlg, %IDC_RichEdit
                         bFindTextInRichEdit 0     '=1 for forward, =0 for backward
                      ElseIf pt.y < 29 Then
                         ChevronColor = 2
                         DrawChevron
                         Control Set Focus hDlg, %IDC_RichEdit
                         bFindTextInRichEdit 1     '=1 for forward, =0 for backward
                      ElseIf pt.y < 45 Then
                         ChevronColor = 3
                         DrawChevron
                         Control Get Text hDlg, %IDC_RichEdit To temp$
                         SetUndo(temp$,1)
                         HighlightTerms
                         Control Set Focus hDlg, %IDC_RichEdit
                      ElseIf pt.y < 60 Then
                         ChevronColor = 4
                         DrawChevron
                         Control Get Text hDlg, %IDC_RichEdit To temp$
                         SetUndo(temp$,1)
                         Control Set Text hDlg, %IDC_RichEdit, GetMatchingLinesOnly(temp$)  '0=any terms
                         HighlightTerms
                         Control Set Focus hDlg, %IDC_RichEdit
                      End If
               End Select
            Case %IDC_LabelFolder
               If Cb.CtlMsg = %STN_DblClk Then
                  Control Get Text hDlg, %IDC_ComboFolders To sFolder
                  If Right$(sFolder,2) = ":\" Then Exit If
                  sFolder = RTrim$(sFolder,"\")
                  sFolder = Left$(sFolder, InStr(-1,sFolder,"\")-1)
                  If Right$(sFolder,1) = ":" Then sFolder = sFolder + "\"
                  Control Set Text hDlg, %IDC_ComboFolders, sFolder
               End If
            Case %IDC_LabelFilter
               If Cb.CtlMsg = %STN_DblClk Then
                  FileFilter = "*"
                  Control Set Text hDlg, %IDC_ComboFilters, FileFilter
               End If
            Case %IDC_ComboFolders
               If Cb.CtlMsg = %LBN_SelChange Then
                  ComboBox Get Text hDlg, %IDC_ComboFolders To sFolder
                  sFolder = RTrim$(sFolder,"\")
               End If
               If (Cb.CtlMsg = %CBN_DropDown) Or (Cb.CtlMsg = %CBN_SelChange) Then
                   xfolders = 0 : yfolders = -1
               End If
            Case %IDC_ComboTerms
               If Cb.CtlMsg = %LBN_SelChange Then
                  ComboBox Get Text hDlg, %IDC_ComboTerms To sTerm
               End If
               If (Cb.CtlMsg = %CBN_DropDown) Or (Cb.CtlMsg = %CBN_SelChange) Then
                   xterms = 0 : yterms = -1
               End If
            Case %IdOk
               If GetParent(GetFocus) = hComboTerms Then
                   Search
               ElseIf GetParent(GetFocus) = hComboFolders Then
                   Search  'SetFocus(hComboFilters)
               ElseIf GetParent(GetFocus) = hComboFilters Then
                   Search  'SetFocus(hComboTerms)
               ElseIf GetFocus = hListView Then
                  ListView Get Select hDlg, %IDC_ListView To iResult
                  If iResult Then
                      ListView Get Text hDlg, %IDC_ListView, iResult, 2  To temp$
                      If ViewFile Then
                          SelectedFile = temp$
                          cprint "lsf - IDOK"
                          LoadSelectedFile
                          SetUndo("",0)
                      Else
                          iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
                      End If
                  End If
               End If
'=========================================================================== ListView Conext Menu Items
            Case %IDM_DisplaySummary
                DisplaySummary
            Case %IDM_RemoveAllResults
                ListView Reset hDlg, %IDC_Listview
                Control Set Text hDlg, %IDC_RichEdit, ""
                SelectedFile = ""
                ClearStatusBarIfListViewEmpty
                SetUndo("",0)
                ResizeWindow
'=========================================================================== ListView Conext Menu Items
            Case %IDM_CheckAll
                ListView Get Count hDlg, %IDC_ListView To iResult
                LVRefreshInWork = 1
                For i = 1 To iResult
                  ListView_SetCheckState hListView, i-1, %True
                Next i
                LVRefreshInWork = 0
            Case %IDM_UnCheckAll
                ListView Get Count hDlg, %IDC_ListView To iResult
                LVRefreshInWork = 1
                For i = 1 To iResult
                  ListView_SetCheckState hListView, i-1, %False
                Next i
                LVRefreshInWork = 0
            Case %IDM_ReverseChecks
                ListView Get Count hDlg, %IDC_ListView To iResult
                LVRefreshInWork = 1
                For i = 1 To iResult
                  x = ListView_GetCheckState(hListView,i-1)
                  ListView_SetCheckState hListView, i-1, IIf(x,%False,%True)
                Next i
                LVRefreshInWork = 0
'=========================================================================== ListView Conext Menu Items
            Case %IDM_RemoveSelected  : RemoveSelectedFile : ClearStatusBarIfListViewEmpty
            Case %IDM_RemoveChecked
                ListView Get Count hDlg, %IDC_ListView To iResult
                For i = iResult To 1 Step -1
                   x = ListView_GetCheckState(hListView,i-1)
                   If x Then ListView Delete Item hDlg, %IDC_ListView, i
                Next i
                ClearStatusBarIfListViewEmpty
            Case %IDM_RemoveUnChecked
                ListView Get Count hDlg, %IDC_ListView To iResult
                For i = iResult To 1 Step -1
                   x = ListView_GetCheckState(hListView,i-1)
                   If x = 0 Then ListView Delete Item hDlg, %IDC_ListView, i
                Next i
                ClearStatusBarIfListViewEmpty
'=========================================================================== ListView Conext Menu Items
            Case %IDM_DeleteSelected  : DeleteSelectedFile  : ClearStatusBarIfListViewEmpty
            Case %IDM_DeleteChecked   : DeleteCheckedFiles  : ClearStatusBarIfListViewEmpty
'=========================================================================== ListView Conext Menu Items
            Case %IDM_SetBaseFolder
                ListView Get Select hDlg, %IDC_ListView To iResult
                If iResult Then
                   ListView Get Text hDlg, %IDC_ListView, iResult, 2 To temp$
                   Control Set Text hDlg, %IDC_ComboFolders, PathName$(Path, temp$)
                Else
                   MsgBoxX "No selection!", %MB_Ok + %MB_IconExclamation,"Set as Base Folder"
                End If
            Case %IDM_OpenFolder
                ListView Get Select hDlg, %IDC_ListView To iResult
                If iResult Then
                    ListView Get Text hDlg, %IDC_ListView, iResult, 2 To temp$
                    temp$ = PathName$(Path, temp$)
                    ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_Restore)
                Else
                   MsgBoxX "No selection!", %MB_Ok + %MB_IconExclamation,"Open Folder Containing Selection"
                End If
'=========================================================================== ListView Conext Menu Items
            Case %IDM_CopyList        :  CopyList
            Case %IDM_CopyChecked     :  CopyChecked
            Case %IDM_OpenWorking     :  OpenWorking
            Case %IDM_ClearWorking    :  Kill Exe.Path$ + "working\*.*"
'=========================================================================== ListView Conext Menu Items
            Case %IDM_CheckDuplicates   :  CheckDuplicates
            Case %IDM_Compare
                Control Get Text hDlg, %IDC_RichEdit To temp$
                SetUndo(temp$,1)
                CompareFiles
'=========================================================================== ListView Conext Menu Items
            Case %IDM_OpenExternally
                ListView Get Select hDlg, %IDC_ListView To iResult
                If iResult Then
                    ListView Get Text hDlg, %IDC_ListView, iResult,2  To temp$
                    iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
                Else
                   MsgBoxX "No selection!", %MB_Ok + %MB_IconExclamation,"Set as Base Folder"
                End If
            Case %IDM_OpenAllDefault     :  OpenCheckedDefaultClient
'=========================================================================== ListView Conext Menu Items
            Case %IDM_OpenCheckedSpecified   :  OpenCheckedSpecifiedClient
            Case %IDM_OpenSelSpecified       :  OpenSelectedSpecifiedClient
            Case %IDM_SpecifyClient          :  SelectClient
            Case %IDM_ExportCSV              :  ExportCSV
            Case %IDM_ExportTXT              :  ExportTXT(1)
            Case %IDM_ExportTXTB             :  ExportTXT(0)
'=========================================================================== ListView Conext Menu Items
            Case %IDM_ToggleDebug
               Debug = Debug Xor 1
               If Debug Then
                  cPrint "Console Display Enabled" + $CrLf + String$(30,"=")
                  Control Set Focus hDlg, %IDC_ComboFolders
               Else
                  FreeConsole
                  hConsole = 0
               End If
            Case %IDM_ClearConsole : ClearConsole

'===RichEdit Context Menu========================================================================
            Case %IDM_RESummary  :  RESummary
'===RichEdit Context Menu========================================================================
            Case %IDM_RichEditCut
                Control Get Text hDlg, %IDC_RichEdit To temp$
                SetUndo(temp$,1)
                SendMessage hRichEdit, %WM_CUT, 0, 0
            Case %IDM_RichEditCopy  : SendMessage hRichEdit, %WM_COPY, 0, 0
            Case %IDM_RichEditPaste
                Control Get Text hDlg, %IDC_RichEdit To temp$
                SetUndo(temp$,1)
                SendMessage hRichEdit, %WM_PASTE, 0, 0
'===RichEdit Context Menu========================================================================
            Case %IDM_RichEditDelete
                Control Get Text hDlg, %IDC_RichEdit To temp$
                SetUndo(temp$,1)
                SendMessage hRichEdit, %WM_CLEAR, 0, 0
'===RichEdit Context Menu========================================================================
            Case %IDM_CopyAll
               Clipboard Reset
               Control Get Text hDlg, %IDC_RichEdit To temp$
               Clipboard Set Text temp$
'===RichEdit Context Menu========================================================================
            Case %IDM_FindFirst
               Control Get Text hDlg, %IDC_ComboTerms To sTerm
               Control Set Focus hDlg, %IDC_RichEdit
               CR.cpMin = 0 : CR.cpMax = 0
               Control Send hDlg, %IDC_RichEdit, %EM_ExSetSel, 0, VarPtr(CR)
               bFindTextInRichEdit 1       '=1 for forward, =0 for backward
            Case %IDM_FindNext
               Control Get Text hDlg, %IDC_ComboTerms To sTerm
               Control Set Focus hDlg, %IDC_RichEdit
               bFindTextInRichEdit 1       '=1 for forward, =0 for backward
            Case %IDM_FindPrevious
               Control Get Text hDlg, %IDC_ComboTerms To sTerm
               Control Set Focus hDlg, %IDC_RichEdit
               bFindTextInRichEdit 0       '=1 for forward, =0 for backward
'===RichEdit Context Menu========================================================================
            Case %IDM_NextDivider       : bFindDividerInRichEdit 1       '=1 for forward, =0 for backward
            Case %IDM_PreviousDivider   : bFindDividerInRichEdit 0       '=1 for forward, =0 for backward
            Case %IDM_OpenDivider       : OpenDivider
'===RichEdit Context Menu========================================================================
            Case %IDM_HighlightTerms
                Control Get Text hDlg, %IDC_RichEdit To temp$
                SetUndo(temp$,1)
                HighlightTerms
            Case %IDM_UnHighlightTerms
                Control Get Text hDlg, %IDC_RichEdit To temp$
                SetUndo(temp$,1)
                TurnOffTermHighlighting
'===RichEdit Context Menu========================================================================
            Case %IDM_MatchingLinesOnly
                Control Get Text hDlg, %IDC_RichEdit To temp$
                SetUndo(temp$,1)
                Control Set Text hDlg, %IDC_RichEdit, GetMatchingLinesOnly(temp$)
                HighlightTerms
'===RichEdit Context Menu========================================================================
            Case %IDM_SortContentA
                Control Get Text hDlg, %IDC_RichEdit To temp$
                SetUndo(temp$,1)
                SortContent "A"
            Case %IDM_SortContentD
                Control Get Text hDlg, %IDC_RichEdit To temp$
                SetUndo(temp$,1)
                SortContent "D"
'===RichEdit Context Menu========================================================================
            Case %IDM_RichEditSave  : SaveREFile SelectedFile
            Case %IDM_RichEditSaveAs: SaveAsREFile
'===RichEdit Context Menu========================================================================
            Case %IDM_ReloadMergeFile : ReloadMergeFile
            Case %IDM_OpenMergeFile
               tempz = Exe.Path$ + "mergefile.txt"
               If IsFile(tempZ) Then
                  i = ShellExecute(hDlg, "Open", tempz, $Nul, $Nul, %SW_ShowNormal)
                  Dialog Set Text hDlg, $Ver + "   " + Exe.Path$ + "mergefile.txt"
                  SetUndo("",0)
               Else
                  MsgBoxX "Merge file not found!", %MB_Ok + %MB_IconExclamation,"Open Merge File"
               End If
'===RichEdit Context Menu========================================================================
            Case %IDM_AddLineNumbers
               Control Get Text hDlg, %IDC_RichEdit To temp$
               SetUndo(temp$,1)
               temp$ = AddLineNumbers(temp$)
               Control Set Text hDlg, %IDC_RichEdit, temp$
            Case %IDM_RemoveLineNumbers
               Control Get Text hDlg, %IDC_RichEdit To temp$
               SetUndo(temp$,1)
               temp$ = RemoveLineNumbers(temp$)
               Control Set Text hDlg, %IDC_RichEdit, temp$
'===RichEdit Context Menu========================================================================
            Case %IDM_RemoveDividers
               Control Get Text hDlg, %IDC_RichEdit To temp$
               SetUndo(temp$,1)
               temp$ = RemoveDividers(temp$)
               Control Set Text hDlg, %IDC_RichEdit, temp$
            Case %IDM_RemoveBlankLines
               Control Get Text hDlg, %IDC_RichEdit To temp$
               SetUndo(temp$,1)
               temp$ = RemoveBlankLines(temp$)
               Control Set Text hDlg, %IDC_RichEdit, temp$
'===RichEdit Context Menu========================================================================

'=============================PowerBASIC=========================================================
            Case %IDM_PBCodec
               If Len(Dir$(Exe.Path$ + "pbcodec.exe")) Then
                   Control Get Text hDlg, %IDC_RichEdit To temp$
                   Open Exe.Path$ + "pbcodec_temp.bas" For Output As #1
                   Print #1, temp$
                   Close #1
                   iResult  = Shell (Exe.Path$ + "pbcodec.exe " + Exe.Path$ + "pbcodec_temp.bas", 1)  'does not wait for it to close
               Else
                   MsgBoxX "PBCodec not found in gbSearch root folder!", %MB_Ok + %MB_IconExclamation,"Open in PBCodec"
               End If
            Case %IDM_PBProcList
                Control Get Text hDlg, %IDC_RichEdit To temp$
                SetUndo(temp$,1)
                temp$ = GetProcList(temp$)
                If Len(temp$) Then
                   Control Set Text hDlg, %IDC_RichEdit, temp$
                Else
                   MsgBoxX "No procedures found!", %MB_Ok + %MB_IconExclamation,"Get Procedure List"
                End If
'=============================PowerBASIC=========================================================
            Case %IDM_RemoveComments
                Control Get Text hDlg, %IDC_RichEdit To temp$
                SetUndo(temp$,1)
                RemoveComments
            Case %IDM_RemoveFType
                Control Get Text hDlg, %IDC_RichEdit To temp$
                SetUndo(temp$,1)
                RemoveFTypes
            Case %IDM_RemoveSplits
                Control Get Text hDlg, %IDC_RichEdit To temp$
                SetUndo(temp$,1)
                RemoveSplits
'======Other Functions=======================================================================
            Case %IDM_UpperCase
               Control Get Text hDlg, %IDC_RichEdit To temp$
               SetUndo(temp$,1)
               Control Set Text hDlg, %IDC_RichEdit, UCase$(temp$)
            Case %IDM_LowerCase
               Control Get Text hDlg, %IDC_RichEdit To temp$
               SetUndo(temp$,1)
               Control Set Text hDlg, %IDC_RichEdit, LCase$(temp$)
'======Other Functions=======================================================================
            Case %IDM_TrimBoth
               Control Get Text hDlg, %IDC_RichEdit To temp$
               SetUndo(temp$,1)
               temp$ = TrimBoth(temp$)
               Control Set Text hDlg, %IDC_RichEdit, Trim$(temp$)
            Case %IDM_TrimLeft
               Control Get Text hDlg, %IDC_RichEdit To temp$
               SetUndo(temp$,1)
               temp$ = TrimLeft(temp$)
               Control Set Text hDlg, %IDC_RichEdit, temp$
            Case %IDM_TrimRight
               Control Get Text hDlg, %IDC_RichEdit To temp$
               SetUndo(temp$,1)
               temp$ = TrimRight(temp$)
               Control Set Text hDlg, %IDC_RichEdit, temp$
'======Other Functions=======================================================================
            Case %IDM_Insert1Col
               Control Get Text hDlg, %IDC_RichEdit To temp$
               SetUndo(temp$,1)
               temp$ = Insert1Col(temp$)
               Control Set Text hDlg, %IDC_RichEdit, temp$
            Case %IDM_Delete1Col
               Control Get Text hDlg, %IDC_RichEdit To temp$
               SetUndo(temp$,1)
               temp$ = Delete1Col(temp$)
               Control Set Text hDlg, %IDC_RichEdit, temp$
'======Other Functions=======================================================================
            Case %IDM_Insert4Col
               Control Get Text hDlg, %IDC_RichEdit To temp$
               SetUndo(temp$,1)
               temp$ = Insert4Col(temp$)
               Control Set Text hDlg, %IDC_RichEdit, temp$
            Case %IDM_Delete4Col
               Control Get Text hDlg, %IDC_RichEdit To temp$
               SetUndo(temp$,1)
               temp$ = Delete4Col(temp$)
               Control Set Text hDlg, %IDC_RichEdit, temp$
'======Other Functions=======================================================================
            Case %IDM_RemoveDupeLines
               Control Get Text hDlg, %IDC_RichEdit To temp$
               SetUndo(temp$,1)
               temp$ = RemoveDupeLines(temp$)
               Control Set Text hDlg, %IDC_RichEdit, temp$
            Case %IDM_RemoveSpaces
               Control Get Text hDlg, %IDC_RichEdit To temp$
               SetUndo(temp$,1)
               temp$ = RemoveSpaces(temp$)
               Control Set Text hDlg, %IDC_RichEdit, temp$
'======Other Functions=======================================================================
            Case %IDM_WordList
               Control Get Text hDlg, %IDC_RichEdit To temp$
               SetUndo(temp$,1)
               temp$ = WordList(temp$)
               Control Set Text hDlg, %IDC_RichEdit, temp$
'======================================================Settings Functions=======================
            Case %IDM_ToolbarText, %IDT_Settings
               ToolbarText = ToolbarText Xor 1
               Dialog Get Client hDlg To x,y
               If UnRestricted Then
                   Dialog Set Client hDlg, IIf(ToolbarText,770,610),y
               Else
                   Dialog Set Client hDlg, IIf(ToolbarText,980,810),y
               End If
               Menu Set State hSettings, ByCmd %IDM_ToolbarText, ToolbarText * 8
               CreateToolbar
               AdjustControlPositions
               ResizeWindow
            Case %IDM_LineColor
                Display Color hDlg, 200, 200, LineColor, CustomColorList ,0 To iResult
                If iResult <> -1 Then
                    LineColor = iResult
                    Control ReDraw hDlg, %IDC_ListView
                End If
            Case %IDM_ColoredLines
               ColoredLines = ColoredLines Xor 1
               Menu Set State hSettings, ByCmd %IDM_ColoredLines, ColoredLines * 8
               Control ReDraw hDlg, %IDC_ListView

            Case %IDM_ExactFileSize
               ExactFileSize = ExactFileSize Xor 1
               Menu Set State hSettings, ByCmd %IDM_ExactFileSize, ExactFileSize * 8
               AdjustSizeDisplay
               ListView Set Header hDlg, %IDC_ListView, 4, IIf$(ExactFileSize,"Bytes","KB")
'======================================================Settings Functions=======================
            Case %IDM_AutoSizeToNone  : AutoSize = %AutoSizeToNone  : SetToolbarMenuStatus : ResizeWindow
            Case %IDM_AutoSizeToWidth : AutoSize = %AutoSizeToWidth : SetToolbarMenuStatus : ResizeWindow
            Case %IDM_AutoSizeToData  : AutoSize = %AutoSizeToData  : SetToolbarMenuStatus : ResizeWindow
'======================================================Settings Functions=======================
            Case %IDM_LineNumbers  'in merge file
               LineNumbers = LineNumbers Xor 1
               Menu Set State hSettings, ByCmd %IDM_LineNumbers, LineNumbers * 8
            Case %IDM_Dividers     'in merge file
               Dividers = Dividers Xor 1
               Menu Set State hSettings, ByCmd %IDM_Dividers, Dividers * 8
            Case %IDM_AutoOpenMerge
                AutoOpenMerge = AutoOpenMerge Xor 1
                Menu Set State hSettings, ByCmd %IDM_AutoOpenMerge, AutoOpenMerge * 8
'======================================================Settings Functions=======================
            'IDM_any, IDM_all, IDM_exact are with their IDC equivalents up above
'======================================================Settings Functions=======================
            'IDM_subfolders, IDM_matchcase are with their IDC equivalents up above
            Case %IDM_HiddenSystem
               HiddenSystem = HiddenSystem Xor 1
               Menu Set State hSettings, ByCmd %IDM_HiddenSystem, HiddenSystem * 8
            Case %IDM_AllowFileDeletion
               AllowFileDeletion = AllowFileDeletion Xor 1
               Menu Set State hSettings, ByCmd %IDM_AllowFileDeletion, AllowFileDeletion * 8

            Case %IDM_Unrestricted
               Unrestricted = Unrestricted Xor 1
               Menu Set State hSettings, ByCmd %IDM_Unrestricted, Unrestricted * 8
               Dialog Get Client hDlg To x,y
               If UnRestricted Then
                   Dialog Set Client hDlg, IIf(ToolbarText,770,600),y
               Else
                   Dialog Set Client hDlg, IIf(ToolbarText,980,810),y
               End If
               Menu Set State hSettings, ByCmd %IDM_ToolbarText, ToolbarText * 8
               CreateToolbar
               AdjustControlPositions
               ResizeWindow
            Case %IDM_ImpliedSearch
               ImpliedSearch = ImpliedSearch Xor 1
               Menu Set State hSettings, ByCmd %IDM_ImpliedSearch, ImpliedSearch * 8
'======================================================Settings Functions=======================
            'IDM_date is with its IDC equivalent up above
            Case %IDM_DateFrom   :  OneOnly = 1 :  ShowCalendarDialog  : SetToolbarMenuStatus
                Statusbar Set Text hDlg, %IDC_Statusbar, 2, 0, DateFromS + " to " + DateToS
            Case %IDM_DateTo     :  OneOnly = 2 :  ShowCalendarDialog  : SetToolbarMenuStatus
                Statusbar Set Text hDlg, %IDC_Statusbar, 2, 0, DateFromS + " to " + DateToS

            Case %IDM_ResetDates
                DateFromS = Date$ : DateToS = Date$
                BuildDateFromDateTo
                SetToolbarMenuStatus
                Statusbar Set Text hDlg, %IDC_Statusbar, 2, 0, DateFromS + " to " + DateToS
'======================================================Settings Functions=======================
            'IDM_size is with its IDC equivalent up above
            Case %IDM_SizeFrom : SizeFrom = SetSize("From")  : SetToolbarMenuStatus
            Case %IDM_SizeTo   : SizeTo   = SetSize("To")    : SetToolbarMenuStatus

'===Folder ComboBox ===========================================================================
            Case %IDM_FolderCut     : SendMessage hComboFoldersEdit, %WM_CUT, 0, 0
            Case %IDM_FolderCopy    : SendMessage hComboFoldersEdit, %WM_COPY, 0, 0
            Case %IDM_FolderPaste   : SendMessage hComboFoldersEdit, %WM_PASTE, 0, 0
            Case %IDM_FolderDelete  : SendMessage hComboFoldersEdit, %WM_CLEAR, 0, 0
            Case %IDM_FolderOpen
               Control Get Text hDlg, %IDC_ComboFolders To temp$
               ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_Restore)
            Case %IDM_FolderUpOne
                Control Get Text hDlg, %IDC_ComboFolders To temp$
                temp$ = RTrim$(temp$,"\")
                Control Set Text hDlg, %IDC_ComboFolders, Left$(temp$, InStr(-1,temp$,"\"))
            Case %IDM_FolderClear   : Reset folderMRU()  : LoadFoldersComboBox
'===Name Filter ComboBox ===========================================================================
            Case %IDM_FiltersCut     : SendMessage hComboFiltersEdit, %WM_CUT, 0, 0
            Case %IDM_FiltersCopy    : SendMessage hComboFiltersEdit, %WM_COPY, 0, 0
            Case %IDM_FiltersPaste   : SendMessage hComboFiltersEdit, %WM_PASTE, 0, 0
            Case %IDM_FiltersDelete  : SendMessage hComboFiltersEdit, %WM_CLEAR, 0, 0
            Case %IDM_FiltersClear   : ReDim filterMRU(0) : filterMRU(0) = "*" : LoadFileFiltersComboBox
'===Search Terms ComboBox ===========================================================================
            Case %IDM_TermsCut      : SendMessage hComboTermsEdit, %WM_CUT, 0, 0
            Case %IDM_TermsCopy     : SendMessage hComboTermsEdit, %WM_COPY, 0, 0
            Case %IDM_TermsPaste    : SendMessage hComboTermsEdit, %WM_PASTE, 0, 0
            Case %IDM_TermsDelete   : SendMessage hComboTermsEdit, %WM_CLEAR, 0, 0
            Case %IDM_TermsClear    : Reset stermMRU()   : LoadSearchTermsComboBox

'hCommand===============================================================
            Case %IDM_hCommand
                hCommand

         End Select

      Case %WM_Notify
          Select Case Cb.NmId
              Case %IDC_StatusBar
                  Select Case Cb.NmCode
                      Case %NM_Click
                         Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, ""
                         Statusbar Set Text hDlg, %IDC_Statusbar, 2, 0, "Date Range: " + DateFromS + " : " + DateToS + "      Size Range (KB): " + Str$(SizeFrom) + " : " + Str$(SizeTo)
                  End Select
              Case %IDC_Calendar
                  Select Case Cb.NmCode
                     Case %MCN_Select
                        iResult = DateTime_GetSystemtime(hCalendar, DT)
                        Dialog Set Text hDlg, Str$(DT.wmonth) + Str$(DT.wday) + Str$(DT.wyear)
                        Control Set Loc hDlg, %IDC_Calendar, -200,-200
                  End Select
              Case %IDC_RichEdit
                  Select Case Cb.NmCode
                     Case %EN_SelChange
                         Statusbar Set Text hdlg, %IDC_StatusBar, 1, 0, "Line#: " + Str$(SendMessage(hRichEdit, %EM_ExLineFromChar, 0, -1))
                  End Select
              Case %IDC_TreeView
                 Select Case Cb.NmCode
                    Case %TVN_ItemExpanding
                       Local N As NM_TreeView Ptr
                       N = Cb.LParam
                       DisplayChildren @N.ItemNew.hItem
                    Case %TVN_SelChanged
                       'Do something when a node is selected
                    Case %NM_DblClk
                       Treeview Get Select hDlg, %IDC_TreeView To hItem
                       sFolder = FullTreePath(hItem)
                       AddToFolderMRU
                       LoadFoldersComboBox
                 End Select
              Case %IDC_Toolbar
                  Select Case Cb.NmCode
                     Case %TBN_DROPDOWN
                        nmtb = Cb.LParam
                        Select Case @nmtb.iItem
                           Case %IDT_ViewTree
                               CreateDriveListMenu
                               SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                               MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                               TrackPopupMenu (hDriveList, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                           Case %IDT_CheckList
                               SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                               MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                               TrackPopupMenu (hExtList, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                           Case %IDT_MergeFiles
                               SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                               MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                               TrackPopupMenu (hMerge, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                           Case %IDT_Settings
                               SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                               MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                               TrackPopupMenu (hSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                           Case %IDT_Date
                               SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                               MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                               TrackPopupMenu (hDate, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                           Case %IDT_Size
                               SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                               MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                               TrackPopupMenu (hSize, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                           Case %IDT_Terms
                               SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                               MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                               TrackPopupMenu (hTerms, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                           End Select
                  End Select
              Case %IDT_Search To %IDT_Size   'button on toolbar - buttons must be sequential equates
                  Select Case Cb.NmCode
                     Case %TTN_GetDispInfo
                         P = Cb.LParam
                         @P.@lpszText = SetToolTips(Cb.NmId)
                  End Select
              Case %IDC_ListView
                  Select Case Cb.NmCode
                     Case %NM_CustomDraw
                         If ColoredLines Then
                             lplvcd = Cb.LParam
                             Select Case @lplvcd.nmcd.dwDrawStage
                                 Case %CDDS_PrePaint
                                     Function = %CDRF_NOTIFYITEMDRAW : Exit Function
                                 Case %CDDS_ItemPrePaint
                                     Select Case @lplvcd.nmcd.dwItemSpec Mod 6
                                         Case 3,4,5
                                             @lplvcd.clrTextBk = LineColor 'item BG color
                                     End Select
                                     Function = %CDRF_NEWFONT : Exit Function   'change item/subitem BG colors
                             End Select
                         End If
                     Case %LVN_ItemChanged
                        If LVActive Then Exit Select
                        ListView Get Select hDlg, %IDC_ListView To iResult
                        ListView Get Text hDlg, %IDC_ListView, iResult,2  To temp$
                        If ViewFile And (LVRefreshInWork = 0) Then
                            SelectedFile = temp$
                            LoadSelectedFile
                            SetUndo("",0)
                        End If
                     Case %NM_DblClk
                        ListView Get Select hDlg, %IDC_ListView To iResult
                        If iResult Then
                            ListView Get Text hDlg, %IDC_ListView, iResult,2  To temp$
'                            If ViewFile = 0 Then
                                iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
'                            End If
                        End If
                     Case %LVN_ColumnClick
                        Type Set LVData = Cb.NmHdr$(SizeOf(LVData))
                        SortDirection = SortDirection Xor 1
                        MousePtr 11 : LVActive = 1
                        If SortDirection Then
                           Select Case LVData.iSubItem+1
                               Case 1 : MousePtr 11 : ListView Sort hDlg, %IDC_ListView, 1, Ascend, UCase : MousePtr 1
                               Case 2 : MousePtr 11 : ListView Sort hDlg, %IDC_ListView, 2, Ascend, UCase : MousePtr 1
                               Case 3 : MousePtr 11 : ListView Sort hDlg, %IDC_ListView, 3, Ascend, UCase : MousePtr 1
                               Case 4
                                   MousePtr 11
                                   RemoveSizeCommas
                                   ListView Sort hDlg, %IDC_ListView, 4, Ascend, Numeric
                                   AdjustSizeDisplay
                                   MousePtr 1
                               Case 5 : MousePtr 11 : ListView Sort hDlg, %IDC_ListView, 5, Ascend, UCase : MousePtr 1
                           End Select
                        Else
                           Select Case LVData.iSubItem+1
                               Case 1 : MousePtr 11 : ListView Sort hDlg, %IDC_ListView, 1, Descend, UCase : MousePtr 1
                               Case 2 : MousePtr 11 : ListView Sort hDlg, %IDC_ListView, 2, Descend, UCase : MousePtr 1
                               Case 3 : MousePtr 11 : ListView Sort hDlg, %IDC_ListView, 3, Descend, UCase : MousePtr 1
                               Case 4
                                   MousePtr 11
                                   RemoveSizeCommas
                                   ListView Sort hDlg, %IDC_ListView, 4, Descend, Numeric
                                   AdjustSizeDisplay
                                   MousePtr 1
                               Case 5 : MousePtr 11 : ListView Sort hDlg, %IDC_ListView, 5, Descend, UCase : MousePtr 1
                           End Select
                        End If
                        LVActive = 0 : MousePtr 1
                        Control ReDraw hDlg, %IDC_ListView
                  End Select
          End Select
      Case %WM_Size
          ResizeWindow
      Case %WM_GETMINMAXINFO
          Local MM As MINMAXINFO Ptr
          If ViewFile Then
              MM=Cb.LParam
              @MM.ptMinTrackSize.y=320  '<-- Min Y size of your window
          Else
              MM=Cb.LParam
              @MM.ptMinTrackSize.y=220  '<-- Min Y size of your window
          End If

      Case %WM_SetCursor
            iResult = GetDlgCtrlID (Cb.WParam)
            If iResult = %IDC_LabelV Then MousePtr 7 : Function = 1    '7 = vertical cursor
            Select Case Hi(Word, Cb.LParam)
               Case %WM_LButtonDown : If iResult = %IDC_LabelV Then SplitVInWork = 1        'sets flags to say splitter action has started (no actual movement yet)
               Case %WM_MouseMove : If SplitVInWork Then If MoveBarUpDown Then ResizeWindow  'Repositions splitter bars to match mouse position (if position has changed)
               Case %WM_LButtonUp : SplitVInWork = 0 : ChevronColor = 0 : DrawChevron'sets flags to say splitter action has ended
            End Select

      Case %WM_ContextMenu
         Select Case Cb.WParam
            Case hListView
               x = Lo(Integer,Cb.LParam) : y = Hi(Integer, Cb.LParam)
               TrackPopupMenu hContextListView, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0
            Case hRichEdit
               x = Lo(Integer,Cb.LParam) : y = Hi(Integer, Cb.LParam)
               TrackPopupMenu hContextViewer, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0
         End Select
      Case %WM_Destroy
         Control Get Text hDlg, %IDC_ComboTerms To sTerm : AddToSearchTermMRU
         Dialog Get Text hDlg To temp$
         If InStr(temp$, "mergefile.txt") Then ViewingMergeFile = 1 Else ViewingMergeFile = 0
         Settings_INI "save"
         SetWindowLong hComboFiltersEdit, %GWL_WNDPROC, OldComboFiltersEditProc&   'un-subclass, restore original window procedure
         SetWindowLong hComboTermsEdit, %GWL_WNDPROC, OldComboTermsEditProc&   'un-subclass, restore original window procedure
         SetWindowLong hComboFoldersEdit, %GWL_WNDPROC, OldComboFoldersEditProc&   'un-subclass, restore original window procedure
   End Select
End Function

Sub Settings_INI(Task$)
   If Debug Then cPrint LCase$(LCase$(FuncName$))
   Local i,x,y As Long,temp$
   Local xResult, yResult, tempz, INIFileName, INIFileNameX As AsciiZ*%Max_Path
   Dim D() As INIData

   'defines file name (any file name will work)
   INIFileName = Exe.Path$ + "gbsearch.ini"
   INIFileNameX = Exe.Path$ + "gbsearch.inx"

   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult$), Val(yResult$)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "980", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "800", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult$), Val(yResult$)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "ImageExt", ".bmp .jpg .gif .png", tempz, %Max_Path, INIFileName
      ImageExt = tempz

      Getprivateprofilestring "All", "DateFromS", Date$, tempz, %Max_Path, INIFileName
      DateFromS = tempz

      Getprivateprofilestring "All", "DateToS", Date$, tempz, %Max_Path, INIFileName
      DateToS = tempz

      Getprivateprofilestring "All", "CustomDivider", "==++==", tempz, %Max_Path, INIFileName
      CustomDivider = tempz

      Getprivateprofilestring "All", "TxtDivider", "++", tempz, %Max_Path, INIFileName
      TxtDivider = tempz

      Getprivateprofilestring "All", "BadChar", ".,+-/\[](){}<>?|*&^%$#@!'-_=:;" + Chr$(34), tempz, %Max_Path, INIFileName
      BadChar = tempz

      Getprivateprofilestring "All", "GoodChar", Chr$("_",65 To 90,97 To 122,48 To 57,"*","?",".",";","#"), tempz, %Max_Path, INIFileName
      GoodChar = tempz

      Getprivateprofilestring "All", "Folder", CurDir$, tempz, %Max_Path, INIFileName
      sFolder = tempz

      Getprivateprofilestring "All", "SearchText", "search", tempz, %Max_Path, INIFileName
      sTerm = tempz

      Getprivateprofilestring "All", "SelectedFile", "", tempz, %Max_Path, INIFileName
      SelectedFile = tempz

      Getprivateprofilestring "All", "SpecifiedClient", "notepad.exe", tempz, %Max_Path, INIFileName
      SpecifiedClient = tempz

      Getprivateprofilestring "All", "Drive", "c:\", tempz, %Max_Path, INIFileName
      Drive = tempz

      'get value for numeric variable
      Getprivateprofilestring "All", "AllowFileDeletion", "0", tempz, %Max_Path, INIFileName  '1MB
      AllowFileDeletion = Val(tempz)

      Getprivateprofilestring "All", "SizeFrom", "1000", tempz, %Max_Path, INIFileName  '1MB
      SizeFrom = Val(tempz)

      Getprivateprofilestring "All", "SizeTo", "10000", tempz, %Max_Path, INIFileName   '10MB
      SizeTo = Val(tempz)

      Getprivateprofilestring "All", "ViewingMergeFile", "0", tempz, %Max_Path, INIFileName
      ViewingMergeFile = Val(tempz)

      Getprivateprofilestring "All", "UseSearchTerms", "0", tempz, %Max_Path, INIFileName
      UseSearchTerms = Val(tempz)

      Getprivateprofilestring "All", "UseDateRange", "0", tempz, %Max_Path, INIFileName
      UseDateRange = Val(tempz)

      Getprivateprofilestring "All", "UseSizeRange", "0", tempz, %Max_Path, INIFileName
      UseSizeRange = Val(tempz)

      Getprivateprofilestring "All", "AutoOpenMerge", "0", tempz, %Max_Path, INIFileName
      AutoOpenMerge = Val(tempz)

      Getprivateprofilestring "All", "VBarTop", "400", tempz, %Max_Path, INIFileName
      VBarTop = Val(tempz)

      Getprivateprofilestring "All", "AutoSize", Str$(%AutoSizeToWidth), tempz, %Max_Path, INIFileName
      AutoSize = Val(tempz)

      Getprivateprofilestring "All", "ColName", "170", tempz, %Max_Path, INIFileName
      ColName = Val(tempz)

      Getprivateprofilestring "All", "ColPath", "540", tempz, %Max_Path, INIFileName
      ColPath = Val(tempz)

      Getprivateprofilestring "All", "ColDate", "110", tempz, %Max_Path, INIFileName
      ColDate = Val(tempz)

      Getprivateprofilestring "All", "ColSize", "110", tempz, %Max_Path, INIFileName
      ColSize = Val(tempz)

      Getprivateprofilestring "All", "ColExt", "50", tempz, %Max_Path, INIFileName
      ColExt = Val(tempz)

      Getprivateprofilestring "All", "Debug", "0", tempz, %Max_Path, INIFileName
      Debug = Val(tempz)

      Getprivateprofilestring "All", "iAll", "1", tempz, %Max_Path, INIFileName
      iAll = Val(tempz)

      Getprivateprofilestring "All", "iBas", "1", tempz, %Max_Path, INIFileName
      iBas = Val(tempz)

      Getprivateprofilestring "All", "iInc", "0", tempz, %Max_Path, INIFileName
      iInc = Val(tempz)

      Getprivateprofilestring "All", "iTxt", "0", tempz, %Max_Path, INIFileName
      iTxt = Val(tempz)

      Getprivateprofilestring "All", "iList", "0", tempz, %Max_Path, INIFileName
      iList = Val(tempz)

      Getprivateprofilestring "All", "ExactCaseMatch", "0", tempz, %Max_Path, INIFileName
      ExactCaseMatch = Val(tempz)

      Getprivateprofilestring "All", "SearchMethod", "1", tempz, %Max_Path, INIFileName
      SearchMethod = Val(tempz)

      Getprivateprofilestring "All", "SubFolders", "0", tempz, %Max_Path, INIFileName
      SubFolders = Val(tempz)

      Getprivateprofilestring "All", "ViewFile", "1", tempz, %Max_Path, INIFileName
      ViewFile = Val(tempz)

      Getprivateprofilestring "All", "ViewTree", "0", tempz, %Max_Path, INIFileName
      ViewTree = Val(tempz)

      Getprivateprofilestring "All", "MaxMRUFolders", "10", tempz, %Max_Path, INIFileName
      MaxMRUFolders = Val(tempz)

      Getprivateprofilestring "All", "MaxMRUFilters", "10", tempz, %Max_Path, INIFileName
      MaxMRUFilters = Val(tempz)

      Getprivateprofilestring "All", "MaxMRUTerms", "10", tempz, %Max_Path, INIFileName
      MaxMRUTerms = Val(tempz)

      Getprivateprofilestring "All", "FileCount", "0", tempz, %Max_Path, INIFileName
      FileCount = Val(tempz)

      Getprivateprofilestring "All", "Dividers", "1", tempz, %Max_Path, INIFileName
      Dividers = Val(tempz)

      Getprivateprofilestring "All", "LineNumbers", "0", tempz, %Max_Path, INIFileName
      LineNumbers = Val(tempz)

      Getprivateprofilestring "All", "HiddenSystem", "0", tempz, %Max_Path, INIFileName
      HiddenSystem = Val(tempz)

      Getprivateprofilestring "All", "Unrestricted", "0", tempz, %Max_Path, INIFileName
      Unrestricted = Val(tempz)

      Getprivateprofilestring "All", "ImpliedSearch", "0", tempz, %Max_Path, INIFileName
      ImpliedSearch = Val(tempz)

      Getprivateprofilestring "All", "ColoredLines", "0", tempz, %Max_Path, INIFileName
      ColoredLines = Val(tempz)

      Getprivateprofilestring "All", "LineColor", Str$(%rgb_PaleGreen), tempz, %Max_Path, INIFileName
      LineColor = Val(tempz)

      Getprivateprofilestring "All", "ExactFileSize", "0", tempz, %Max_Path, INIFileName
      ExactFileSize = Val(tempz)

      Getprivateprofilestring "All", "ToolbarText", "1", tempz, %Max_Path, INIFileName
      ToolbarText = Val(tempz)

      For i = 0 To 15
         Getprivateprofilestring "Custom", "CustomColor" + Format$(i,"00"), "", tempz, %Max_Path, INIFileName
         CustomColorList.c(i) = Val(tempz)
      Next i

      Dim stermMRU(MaxMRUTerms-1)
      For i = 0 To UBound(stermMRU)
         Getprivateprofilestring "Arrays", "Terms" + Format$(i,"00"), "", tempz, %Max_Path, INIFileName
         stermMRU(i) = tempz
      Next i
      If stermMRU(0) = "" Then stermMRU(0) = "<empty>"

      Dim filterMRU(MaxMRUFilters-1)
      For i = 0 To UBound(filterMRU)
         Getprivateprofilestring "Arrays", "Filters" + Format$(i,"00"), "", tempz, %Max_Path, INIFileName
         filterMRU(i) = tempz
      Next i
      If filterMRU(0) = "" Then filterMRU(0) = "*"

      Dim folderMRU(MaxMRUFolders-1)
      x = 0
      For i = 0 To UBound(folderMRU)
         Getprivateprofilestring "Arrays", "Folders" + Format$(i,"00"), "", tempz, %Max_Path, INIFileName
         If IsFolder(tempz) Then folderMRU(x) = tempz : Incr x   'delete folders which do not exist
      Next i
      If x = 0 Then folderMRU(x) = CurDir$

      'set DateFrom/DateTo from DateFromS/DateToS
      BuildDateFromDateTo

      'inifilenamex is manually loaded because INI API are too slow for this many reads
      ListView Set Column hDlg, %IDC_Listview, 1, ColName
      ListView Set Column hDlg, %IDC_Listview, 2, ColPath
      ListView Set Column hDlg, %IDC_Listview, 3, ColDate
      ListView Set Column hDlg, %IDC_Listview, 4, ColSize
      ListView Set Column hDlg, %IDC_Listview, 5, ColExt
      If FileCount And Len(Dir$(INIFileNameX)) Then
          ReDim D(FileCount)
          Open INIFileNameX For Binary As #1
          Get #1,,D()
          Close #1
          For i = 1 To FileCount    ' To 1 Step -1
             ListView Insert Item hDlg, %IDC_ListView, i, 0, Trim$(PathName$(Namex,D(i).path))
             ListView Set Text hDlg, %IDC_ListView, i, 2, Trim$(D(i).path)
             ListView_SetCheckState hListView, i-1 , D(i).Status
             ListView Set Text hDlg, %IDC_ListView, i,3, D(i).date
             ListView Set Text hDlg, %IDC_ListView, i,4, Trim$(D(i).Size)
             ListView Set Text hDlg, %IDC_ListView, i,5, Trim$(D(i).Ext)
          Next
      End If
      Statusbar Set Text hDlg, %IDC_Statusbar, 2, 0, Format$(FileCount,"#,###") + " matching files."

      SetToolbarMenuStatus
   End If

   If Task$ = "save" Then
      If Len(Dir$(INIFileName)) Then Kill INIFileName
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If

      'save string variables
      WritePrivateProfileString "All", "DateFromS", (DateFromS), INIFileName
      WritePrivateProfileString "All", "DateToS", (DateToS), INIFileName

      WritePrivateProfileString "All", "CustomDivider", (CustomDivider), INIFileName
      WritePrivateProfileString "All", "TxtDivider", (CustomDivider), INIFileName
      WritePrivateProfileString "All", "BadChar", (BadChar), INIFileName
      WritePrivateProfileString "All", "GoodChar", (GoodChar), INIFileName
      WritePrivateProfileString "All", "Folder", (sFolder), INIFileName
      WritePrivateProfileString "All", "SearchText", (sTerm), INIFileName

      ListView Get Select hDlg, %IDC_ListView To i
      If i Then ListView Get Text hDlg, %IDC_ListView, i, 2  To SelectedFile
      WritePrivateProfileString "All", "SelectedFile", (SelectedFile), INIFileName

      WritePrivateProfileString "All", "SpecifiedClient", (SpecifiedClient), INIFileName
      WritePrivateProfileString "All", "Drive", (Drive), INIFileName

      'save numeric variable
      WritePrivateProfileString "All", "AllowFileDeletion", (Str$(AllowFileDeletion)), INIFileName
      WritePrivateProfileString "All", "SizeFrom", (Str$(SizeFrom)), INIFileName
      WritePrivateProfileString "All", "SizeTo", (Str$(SizeTo)), INIFileName
      WritePrivateProfileString "All", "ViewingMergeFile", (Str$(ViewingMergeFile)), INIFileName
      WritePrivateProfileString "All", "UseSearchTerms", (Str$(UseSearchTerms)), INIFileName
      WritePrivateProfileString "All", "UseDateRange", (Str$(UseDateRange)), INIFileName
      WritePrivateProfileString "All", "UseSizeRange", (Str$(UseSizeRange)), INIFileName

      WritePrivateProfileString "All", "AutoOpenMerge", (Str$(AutoOpenMerge)), INIFileName
      WritePrivateProfileString "All", "VBarTop", (Str$(VBarTop)), INIFileName
      WritePrivateProfileString "All", "AutoSize", (Str$(AutoSize)), INIFileName
      ListView Get Column hDlg, %IDC_Listview, 1 To ColName
      WritePrivateProfileString "All", "ColName", (Str$(ColName)), INIFileName
      ListView Get Column hDlg, %IDC_Listview, 2 To ColPath
      WritePrivateProfileString "All", "ColPath", (Str$(ColPath)), INIFileName
      ListView Get Column hDlg, %IDC_Listview, 3 To ColDate
      WritePrivateProfileString "All", "ColDate", (Str$(ColDate)), INIFileName
      ListView Get Column hDlg, %IDC_Listview, 4 To ColSize
      WritePrivateProfileString "All", "ColSize", (Str$(ColSize)), INIFileName
      ListView Get Column hDlg, %IDC_Listview, 5 To ColExt
      WritePrivateProfileString "All", "ColExt", (Str$(ColExt)), INIFileName
      WritePrivateProfileString "All", "Debug", (Str$(Debug)), INIFileName
      WritePrivateProfileString "All", "iAll", (Str$(iAll)), INIFileName
      WritePrivateProfileString "All", "iBas", (Str$(iBas)), INIFileName
      WritePrivateProfileString "All", "iInc", (Str$(iInc)), INIFileName
      WritePrivateProfileString "All", "iTxt", (Str$(iTxt)), INIFileName
      WritePrivateProfileString "All", "iList", (Str$(iList)), INIFileName
      WritePrivateProfileString "All", "ExactCaseMatch", (Str$(ExactCaseMatch)), INIFileName
      WritePrivateProfileString "All", "SearchMethod", (Str$(SearchMethod)), INIFileName
      WritePrivateProfileString "All", "SubFolders", (Str$(SubFolders)), INIFileName
      WritePrivateProfileString "All", "ViewFile", (Str$(ViewFile)), INIFileName
      WritePrivateProfileString "All", "ViewTree", (Str$(ViewTree)), INIFileName
      WritePrivateProfileString "All", "MaxMRUFolders", (Str$(MaxMRUFolders)), INIFileName
      WritePrivateProfileString "All", "MaxMRUFilters", (Str$(MaxMRUFilters)), INIFileName
      WritePrivateProfileString "All", "MaxMRUTerms", (Str$(MaxMRUTerms)), INIFileName
      ListView Get Count hDlg, %IDC_ListView To FileCount
      WritePrivateProfileString "All", "FileCount", (Str$(FileCount)), INIFileName
      WritePrivateProfileString "All", "Dividers", (Str$(Dividers)), INIFileName
      WritePrivateProfileString "All", "LineNumbers", (Str$(LineNumbers)), INIFileName
      WritePrivateProfileString "All", "HiddenSystem", (Str$(HiddenSystem)), INIFileName
      WritePrivateProfileString "All", "Unrestricted", (Str$(Unrestricted)), INIFileName
      WritePrivateProfileString "All", "ImpliedSearch", (Str$(ImpliedSearch)), INIFileName
      WritePrivateProfileString "All", "LineColor", (Str$(LineColor)), INIFileName
      WritePrivateProfileString "All", "ColoredLines", (Str$(ColoredLines)), INIFileName
      WritePrivateProfileString "All", "ExactFileSize", (Str$(ExactFileSize)), INIFileName
      WritePrivateProfileString "All", "ToolbarText", (Str$(ToolbarText)), INIFileName

      For i = 0 To 15
         tempz = Str$(CustomColorList.c(i))
         WritePrivateProfileString "Custom", "CustomColor" + Format$(i,"00"), tempz, INIFileName
      Next i

      For i = 0 To UBound(stermMRU)
         tempz = stermMRU(i)
         WritePrivateProfileString "Arrays", "Terms" + Format$(i,"00"), tempz, INIFileName
      Next i

      For i = 0 To UBound(filterMRU)
         tempz = filterMRU(i)
         WritePrivateProfileString "Arrays", "Filters" + Format$(i,"00"), tempz, INIFileName
      Next i

      For i = 0 To UBound(folderMRU)
         tempz = folderMRU(i)
         WritePrivateProfileString "Arrays", "Folders" + Format$(i,"00"), tempz, INIFileName
      Next i

      'inifilenamex is manually loaded because INI API are too slow for this many writes
      If FileCount Then
          ReDim D(FileCount)
          For i = 1 To FileCount
             temp$ = Format$(i,"00")
             ListView Get Text hDlg, %IDC_ListView, i, 2  To D(i).path
             D(i).Status = ListView_GetCheckState(hListView,i - 1)
             ListView Get Text hDlg, %IDC_ListView, i, 3  To D(i).date
             ListView Get Text hDlg, %IDC_ListView, i, 4  To D(i).Size
             ListView Get Text hDlg, %IDC_ListView, i, 5  To D(i).ext
          Next i
          If Len(Dir$(INIFileNameX)) Then Kill INIFileNameX
          Open INIFileNameX For Binary As #1
          Put #1,, D()
          Close #1
      End If
   End If
End Sub

Sub SetToolbarMenuStatus
   If Debug Then cPrint LCase$(FuncName$)
   'Toolbars
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_CheckAll, %TBState_Checked * iAll Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_CheckBas, %TBState_Checked * iBas Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_CheckInc, %TBState_Checked * iInc Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_CheckTxt, %TBState_Checked * iTxt Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_CheckList, %TBState_Checked * iList Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_ExactCaseMatch, %TBState_Checked * ExactCaseMatch Or %TBState_Enabled

   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Terms, %TBState_Checked * UseSearchTerms Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Date, %TBState_Checked * UseDateRange Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Size, %TBState_Checked * UseSizeRange Or %TBState_Enabled

   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_SubFolders, %TBState_Checked * SubFolders Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_ViewFile, %TBState_Checked * ViewFile Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_ViewTree, %TBState_Checked * ViewTree Or %TBState_Enabled

   'Menus
   Menu Set State hSettings, ByCmd %IDM_LineNumbers, LineNumbers * 8
   Menu Set State hSettings, ByCmd %IDM_HiddenSystem, HiddenSystem * 8
   Menu Set State hSettings, ByCmd %IDM_AllowFileDeletion, AllowFileDeletion * 8
   Menu Set State hSettings, ByCmd %IDM_Unrestricted, Unrestricted * 8
   Menu Set State hSettings, ByCmd %IDM_ImpliedSearch, ImpliedSearch * 8
   Menu Set State hSettings, ByCmd %IDM_Dividers, Dividers * 8
   Menu Set State hSettings, ByCmd %IDM_AutoOpenMerge, AutoOpenMerge * 8
   Menu Set State hSettings, ByCmd %IDM_ColoredLines, ColoredLines * 8
   Menu Set State hSettings, ByCmd %IDM_ExactFileSize, ExactFileSize * 8
   ListView Set Header hDlg, %IDC_ListView, 4, IIf$(ExactFileSize,"Bytes","KB")
   Menu Set State hSettings, ByCmd %IDM_ToolbarText, ToolbarText * 8

   Menu Set State hSettings, ByCmd %IDM_AutoSizeToNone, 0
   Menu Set State hSettings, ByCmd %IDM_AutoSizeToWidth, 0
   Menu Set State hSettings, ByCmd %IDM_AutoSizeToData, 0
   Select Case AutoSize
       Case %AutoSizeToNone  : Menu Set State hSettings, ByCmd %IDM_AutoSizeToNone, 8
       Case %AutoSizeToWidth : Menu Set State hSettings, ByCmd %IDM_AutoSizeToWidth, 8
       Case %AutoSizeToData  : Menu Set State hSettings, ByCmd %IDM_AutoSizeToData, 8
   End Select

   Menu Set State hTerms, ByCmd %IDM_All, 0
   Menu Set State hTerms, ByCmd %IDM_Any, 0
   Menu Set State hTerms, ByCmd %IDM_Exact, 0
   Select Case SearchMethod
       Case %AllTerms    : Menu Set State hTerms, ByCmd %IDM_All, 8
       Case %AnyTerms    : Menu Set State hTerms, ByCmd %IDM_Any, 8
       Case %ExactString : Menu Set State hTerms, ByCmd %IDM_Exact, 8
   End Select

   Menu Set State hSettings, ByCmd %IDT_Terms, UseSearchTerms * 8

   Menu Set State hSettings, ByCmd %IDM_Date, UseDateRange * 8
   Menu Set Text hSettings, ByCmd %IDM_DateFrom, "From:  " + DateFromS
   Menu Set Text hSettings, ByCmd %IDM_DateTo, "To:      " + DateToS
   Menu Set Text hDate, ByCmd %IDM_DateFrom, "From:  " + DateFromS
   Menu Set Text hDate, ByCmd %IDM_DateTo, "To:      " + DateToS

   Menu Set State hSettings, ByCmd %IDM_Size, UseSizeRange * 8
   Menu Set Text hSettings, ByCmd %IDM_SizeFrom, "Min:    " + Format$(SizeFrom,"###,###,###") + " KB"
   Menu Set Text hSettings, ByCmd %IDM_SizeTo, "Max:  " + Format$(SizeTo,"###,###,###") + " KB"
   Menu Set Text hSize, ByCmd %IDM_SizeFrom, "Min:    " + Format$(SizeFrom,"###,###,###") + " KB"
   Menu Set Text hSize, ByCmd %IDM_SizeTo, "Max:  " + Format$(SizeTo,"###,###,###") + " KB"

   Menu Set State hSettings, ByCmd %IDM_MatchCase, ExactCaseMatch * 8
   Menu Set State hSettings, ByCmd %IDM_SubFolders, SubFolders * 8
End Sub

Function SetToolTips(cID As Long) As String
   If Debug Then cPrint LCase$(FuncName$)
   Select Case cID          'or this:   @P.hdr.idFrom
      Case %IDT_Search         : Function = "Search for Matching Files"
      Case %IDT_MergeFiles     : Function = "Create Merged Text File (Selected Files Only)"
      Case %IDT_ViewFile       : Function = "Display File Viewer"
      Case %IDT_ViewTree       : Function = "Display Folder Tree"
      Case %IDT_SelectFolder   : Function = "Select Folder/Drive"
      Case %IDT_CheckAll       : Function = "All Extensions (Restricted)"
      Case %IDT_CheckBas       : Function = ".bas Extensions"
      Case %IDT_CheckInc       : Function = ".inc Extensions"
      Case %IDT_CheckTxt       : Function = ".txt Extensions"
      Case %IDT_CheckList      : Function = "Use All Extensions in List"
      Case %IDT_ExactCaseMatch : Function = "Match Case"

      Case %IDT_Terms          : Function = "Limit Search to Files Matching Search Terms"
      Case %IDT_Date           : Function = "Limit Search To Files Within Date Range"
      Case %IDT_Size           : Function = "Limit Search to Files Within Size Range"

      Case %IDT_SubFolders     : Function = "Include SubFolders"
      Case %IDT_Settings       : Function = "Settings"
      Case %IDT_Help           : Function = "Help (Web Site)"
      Case Else                : Function = "Unknown"
   End Select
End Function

Function MoveBarUpDown As Long
   If Debug Then cPrint LCase$(FuncName$)
    Local pt As Point, h As Long, w As Long
    Static oldY As Long
    Dialog Get Client hDlg To w,h
    GetCursorPos pt               'pt has xy screen coordinates
    ScreenToClient hDlg, pt       'pt now has client coordinates
    VBarTop = Pt.y-3        'actually, should only do one or the other
    If pt.y <> oldY Then Function = %True : oldY = pt.y
End Function

Sub SetToolTip(hControl As Dword, TipText As AsciiZ*256)
   If Debug Then cPrint LCase$(FuncName$)
      Local TI As TOOLINFO
      TI.cbSize    = Len(TI)
      TI.uFlags    = %TTF_SUBCLASS Or %TTF_IDISHWND
      TI.hWnd      = GetParent(hToolTip)
      TI.uId       = hControl
      TI.lpszText  = VarPtr(TipText)
      SendMessage hToolTip, %TTM_ADDTOOL, 0, VarPtr(ti)
End Sub

Sub AdjustControlPositions
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long
    i = ViewTree * 210
    If ToolbarText Then
        Control Set Loc hDlg, %IDC_LabelFolder, 10,55
        Control Set Loc hDlg, %IDC_ComboFolders, 80,55

        Control Set Loc hDlg, %IDC_LabelFilter, 10,85
        Control Set Loc hDlg, %IDC_ComboFilters,80,85

        Control Set Loc hDlg, %IDC_LabelTerm, 200,85
        Control Set Loc hDlg, %IDC_ComboTerms,280,85

        Control Set Loc hDlg, %IDC_ListView,i+10,115
        Control Set Loc hDlg, %IDC_TreeView,10,115
    Else
        Control Set Loc hDlg, %IDC_LabelFolder, 10,40
        Control Set Loc hDlg, %IDC_ComboFolders, 80,40

        Control Set Loc hDlg, %IDC_LabelFilter, 10,70
        Control Set Loc hDlg, %IDC_ComboFilters,80,70

        Control Set Loc hDlg, %IDC_LabelTerm, 200,70
        Control Set Loc hDlg, %IDC_ComboTerms,280,70

        Control Set Loc hDlg, %IDC_ListView,i+10,100
        Control Set Loc hDlg, %IDC_TreeView,10,100
    End If
    Dialog ReDraw hDlg
End Sub

Sub ResizeWindow
   If Debug Then cPrint LCase$(FuncName$)
   If IsIconic(hDlg) Then Exit Sub

   Local x,xx,w,h As Long
   Dialog Get Client hDlg To w,h

   'size
   If w > 170 Then Control Set Size hDlg, %IDC_ComboFolders, w-90, 20
   If w > 400 Then Control Set Size hDlg, %IDC_ComboTerms, w-290, 20

   'size LV columns
   Select Case AutoSize
       Case %AutoSizeToNone
           'no action
       Case %AutoSizeToData
          SendMessage GetDlgItem(hDlg, %IDC_ListView), %LVM_SetColumnWidth, 0, %LVSCW_AutoSize_UseHeader
          SendMessage GetDlgItem(hDlg, %IDC_ListView), %LVM_SetColumnWidth, 1, %LVSCW_AutoSize_UseHeader
          SendMessage GetDlgItem(hDlg, %IDC_ListView), %LVM_SetColumnWidth, 2, %LVSCW_AutoSize_UseHeader
          SendMessage GetDlgItem(hDlg, %IDC_ListView), %LVM_SetColumnWidth, 3, %LVSCW_AutoSize_UseHeader
          SendMessage GetDlgItem(hDlg, %IDC_ListView), %LVM_SetColumnWidth, 4, %LVSCW_AutoSize_UseHeader
       Case %AutoSizeToWidth
          If (GetWindowLong(hListView, %GWL_STYLE) And %WS_VScroll) Then xx = 15 ' Vertical scrollbar is visible
          x = (w-20-xx-ViewTree*210) * 0.15  : ListView_SetColumnWidth(hListView, 0, x)
          x = (w-20-xx-ViewTree*210) * 0.50  : ListView_SetColumnWidth(hListView, 1, x)
          x = (w-20-xx-ViewTree*210) * 0.17  : ListView_SetColumnWidth(hListView, 2, x)
          x = (w-20-xx-ViewTree*210) * 0.10  : ListView_SetColumnWidth(hListView, 3, x)
          x = (w-20-xx-ViewTree*210) * 0.077 : ListView_SetColumnWidth(hListView, 4, x)
   End Select

   'visibility
   If VBarTop > 125 Then Control Show State hDlg, %IDC_LabelV, IIf(ViewFile, %SW_Show, %SW_Hide)
   If VBarTop > 125 Then Control Show State hDlg, %IDC_RichEdit, IIf(ViewFile, %SW_ShowNoActivate, %SW_Hide)
   Control Show State hDlg, %IDC_TreeView, IIf(ViewTree, %SW_Show, %SW_Hide)
   Control Show State hDlg, %IDC_Graphic, IIf(ViewFile, %SW_Show, %SW_Hide)

   If ViewFile Then
      If VBarTop < (IIf(ToolbarText, 65,50) + 140) Then VBarTop = (IIf(ToolbarText, 65,50) + 140)
      If VBarTop > (h-100) Then VBarTop = h-100

      Control Set Size hDlg, %IDC_LabelV, w, 6
      Control Set Loc hDlg, %IDC_LabelV, 0, VBarTop

      Control Set Size hDlg, %IDC_TreeView, 200, VBarTop - IIf(ToolbarText, 120,105)
      Control Set Size hDlg, %IDC_ListView, w-20-ViewTree*210, VBarTop - IIf(ToolbarText, 120,105)

      Control Set Loc hDlg, %IDC_RichEdit, 10, VBarTop + 10
      Control Set Size hDlg, %IDC_RichEdit, w-20, h - VBarTop - 35

      Control Set Loc hDlg, %IDC_Graphic, 0, VBartop + 15
      DrawChevron
   Else
      Control Set Size hDlg, %IDC_TreeView, 200, h-IIf(ToolbarText, 125,110)-15
      Control Set Size hDlg, %IDC_ListView, w-20-ViewTree*210, h-IIf(ToolbarText, 125, 110)-15
   End If

   Control ReDraw hDlg, %IDC_RichEdit

   PostMessage hComboTerms,%CB_SeteditSel, 0, Mak(Long,-1,0)
   PostMessage hComboFolders,%CB_SeteditSel, 0, Mak(Long,-1,0)
End Sub

Function SBProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   If Debug Then cPrint LCase$(FuncName$)
   Local x As Long, y As Long    'MsgBoxX is approximately 200x200
   CenterOverDialog 200,200,x,y
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x,y, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx hHook
   End If
End Function

Function MsgBoxX(msg$,Flag As Long,caption$) As Long
   hHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
   Function = MessageBox( 0, (msg$), (caption$), Flag)
End Function

Sub CenterOverDialog(BoxX As Long, BoxY As Long, CenterX As Long, CenterY As Long)
   If Debug Then cPrint LCase$(FuncName$)
   'gets top/left position to center Box over Dialog
   'you need to know, or at least estimate, the Box size
   Local x As Long, y As Long, w As Long, h As Long
   Dialog Get Loc hDlg To x,y
   Dialog Get Size hDlg To w,h
   CenterX = x + (w-BoxX)/2
   CenterY = y + (h-BoxY)/2
End Sub

'====Toolbar Functions================================================================
Sub SelectFolder
   If Debug Then cPrint LCase$(FuncName$)
   Local title$, start$, flags&, folder$
   title$ = "Select Folder"
   start$ = sFolder
   flags& = %BIF_ReturnOnlyFSDirs Or %BIF_DontGoBelowDomain Or %BIF_NoNewFolderButton
   Display Browse  hDlg, 100, 100, title$, start$, flags& To folder$   'folder$ is set to "" if Cancel/Escape is pressed
   If Len(folder$) Then sFolder = folder$
End Sub

Sub CreateDriveListMenu
   If Debug Then cPrint LCase$(FuncName$)
   Local i, iCount As Long, sDrives As String     'buffer to hold return from API
   sDrives = String$(104," ")   'size the buffer - '"c:\" + nul = 4 bytes x 26 possible letter drives = 104
   GetLogicalDriveStrings 1044, ByVal StrPtr(sDrives)
   Replace Chr$(0) With "   " In sDrives
   Menu New PopUp To hDriveList
   For i = 65 To 90
      If InStr(sDrives, Chr$(i)) Then
         Menu Add String, hDriveList, Chr$(i) + ":\", %IDM_Drive + iCount,  %MF_Enabled
         Incr iCount
      End If
   Next i
End Sub


Sub Search
   If Debug Then cPrint LCase$(FuncName$)
   Local iPos, FilesSearched As Long, tempDir As DirData
   Local iCount As Long, temp$
   Local iResultTerm, iResultDate, iResultSize As Long

   'check to see if file extensions have been selected
   If Unrestricted = 0 And iAll = 0 And iBas=0 And iInc=0 And iTxt=0 And iList=0 Then
       MsgBoxX "No file extension types selected!", %MB_Ok + %MB_IconExclamation, "Search"
       Exit Sub
   End If

   MousePtr 11
   Dialog Set Text hDlg,  $Ver

   'keep time
   QueryPerformanceCounter qStart

   'use current folder
   Control Get Text hDlg, %IDC_ComboFolders To sFolder
   sFolder = RTrim$(sFolder,"\")
   If IsFalse(IsFolder(sFolder)) Then
       MsgBoxX "Invalid Folder!", %MB_Ok + %MB_IconExclamation, "Search"
       Exit Sub
   End If
   AddToFolderMRU
   LoadFoldersComboBox
   Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, ""
   Statusbar Set Text hDlg, %IDC_Statusbar, 2, 0, ""

   'use current search term (if not zero length)
   Control Get Text hDlg, %IDC_ComboTerms To sTerm
   If Len(sterm) = 0 And UseSearchTerms = 1 Then
       MsgBoxX "No search terms!", %MB_Ok + %MB_IconExclamation, "Search"
       Exit Sub
   End If
   AddToSearchTermMRU : LoadSearchTermsComboBox
   CreateSearchTermArray                             'also sets bMethod

   'use current file filter (if not zero length). remove invalid characters
   Control Get Text hDlg, %IDC_ComboFilters To FileFilter
'   FileFilter = Retain$(FileFilter, Any Chr$("_",65 To 90,97 To 122,49 To 57,"*","?",".",";"))
   FileFilter = Retain$(FileFilter, Any GoodChar)
   If Len(Trim$(FileFilter)) = 0 Then FileFilter = "*"
   If Right$(FileFilter,1) = "." Then FileFilter = Left$(FileFilter, Len(FileFilter)-1) 'not allow . as last char
   If UnRestricted = 0 Then FileFilter = PathName$(Name,FileFilter)
   AddToFileFilterMRU : LoadFileFiltersComboBox
   If ImpliedSearch Then FileFilter = "*" + Trim$(FileFilter,"*") + "*"

   'create TextExt
   UpdateTextExt

   'createFileSpec
   FileSpec = ""
   If Unrestricted Then
      FileSpec = FileFilter  'FileSpec + "*.*"
   Else
      If (iBas Or iAll) Then FileSpec = FileSpec + FileFilter + ".bas;"
      If (iInc Or iAll) Then FileSpec = FileSpec + FileFilter + ".inc;"
      If (iTxt Or iAll) Then FileSpec = FileSpec + FileFilter + ".txt;"
      If (iList Or iAll) Then
          Open Exe.Path$ + "extensions.txt" For Input As #1
          While IsFalse(Eof(1))
              Line Input #1, temp$
              If Len(Trim$(temp$)) Then
                  FileSpec = FileSpec + FileFilter + "." + temp$ + ";"
                  TextExt = TextExt + " ." + temp$
              End If
          Wend
          Close #1
       End If
   End If

   Control Set Text hDlg, %IDC_RichEdit, ""
   ListView Reset hDlg, %IDC_ListView
   Reset Files(), Folders(), FileCount, FolderCount

   'get folder/file lists
   Folders(iPos).FileName = sFolder     'no ending \
   Do While Len(Folders(iPos).FileName)
       temp$ = Dir$(Folders(iPos).FileName + "\*.*", %Normal + %SubDir + IIf(HiddenSystem, %System + %Hidden, 0), To tempDir)
       Do While Len(temp$)
           If (tempDir.FileAttributes And %File_Attribute_Directory) = 0 Then  'files
               Incr FilesSearched
               If PathMatchSpec((tempDir.Filename), (FileSpec)) Then  'valid extension
                   iResultTerm = 1 : iResultDate = 1 : iResultSize = 1
                   'date
                   If  UseDateRange Then   'does file meet date criteria (if applies)
                       If CompareFileTime(ByVal VarPtr(tempDir.LastWriteTime),DateFrom) = -1 _
                       Or CompareFileTime(ByVal VarPtr(tempDir.LastWriteTime),DateTo) = 1 Then iResultDate = 0
                   End If
                   'size
                   If iResultDate And UseSizeRange Then
                       If (FileInSizeRange(tempDir.FileSizeHigh,tempDir.FileSizeLow)=0) Then iResultSize = 0
                   End If
                   'terms
                   If iResultDate And iResultSize And UseSearchTerms Then
                       If (SearchInSideFile((Folders(iPos).FileName + "\" + tempDir.FileName))=0) Then iResultTerm = 0
                   End If
                   'keep if matches all criteria
                   If iResultTerm And iResultDate And iResultSize Then  'if file meets all 3 tests, then add file to search results list
                      tempDir.FileName = Folders(iPos).FileName + "\" + tempDir.FileName
                      Incr FileCount
                      Files(FileCount) = tempDir
                      Files(FileCount).FileName = LCase$(Files(FileCount).FileName)
                   End If
               End If
           Else                                                                'folder
               If SubFolders Then
                   tempDir.FileName = Folders(iPos).FileName + "\" + tempDir.FileName
                   Incr FolderCount
                   Folders(FolderCount) = tempDir
               End If
           End If
           temp$ = Dir$(Next, To tempDir)
       Loop
       Incr iPos
   Loop

   QueryPerformanceCounter qStop
   Statusbar Set Text hdlg, %IDC_StatusBar, 2, 0, Str$(FileCount) + " matching" + IIf$(FileCount=1," file"," files") + " found.    " + Format$((qStop-qStart)/qFreq,"###.000") & " seconds     " + Str$(FilesSearched) + " files searched."

   LoadListViewFromFilesArray  'load ListView with results (if usesearchterms then go through each file for content before adding to listview)
   ListView Get Count hDlg, %IDC_ListView To iCount
   If iCount = 0 Then
       ListView Insert Item hDlg, %IDC_ListView, 1, 0, "<no matches>"
   Else
       ListView Select hDlg, %IDC_ListView, 1
   End If

   MousePtr 1

End Sub

Function FileInSizeRange(FileSizeHigh As Dword, FileSizeLow As Dword) As Long
    If Debug Then cPrint LCase$(FuncName$)
    Local FileSize As Long
    FileSize = FileSizeHigh * &H100000000 + FileSizeLow
    If (FileSize >= SizeFrom*1024) And (FileSize <= SizeTo*1024) Then Function = 1
End Function

Function SearchInsideFile(fName$) As Long
   If Debug Then cPrint LCase$(FuncName$)

   If InStr(TextExt, PathName$(Extn,LCase$(fName$))) = 0 Then Exit Function

   Local fText$, i,iResult As Long, xTerm$
   xTerm$ = IIf$(ExactCaseMatch, sTerm, LCase$(sTerm))

   Open fName$ For Binary As #1 : Get$ #1, Lof(1), fText$ : Close #1
   If ExactCaseMatch = 0 Then fText$ = LCase$(fText$)    'upper/lower case as appropriate

   Select Case SearchMethod
       Case %AllTerms   ' &
          iResult = 1
          'test if all terms are somewhere in the document - covers non-Boolean search
          For i = 0 To UBound(T)
             If InStr(fText$,T(i)) = 0  Then iResult = 0 : Exit For
          Next
       Case %AnyTerms   ' |
          'test if any term is anywhere in the document
          For i = 0 To UBound(T)
             If InStr(fText$,T(i)) Then iResult = 1 : Exit For
          Next i
       Case %ExactString  'use string as typed in by the user
          If InStr(fText$,xTerm$) Then iResult = 1
   End Select
   Function = iResult
End Function

Sub CreateSearchTermArray
   If Debug Then cPrint LCase$(FuncName$)
   Local xTerm$
   Control Get Text hDlg, %IDC_ComboTerms To sTerm
   xTerm$ = IIf$(ExactCaseMatch, sTerm, LCase$(sTerm))

   'create array of search terms (ignore and/AND, or/OR)
   If SearchMethod = %ExactString Then
      ReDim T(0) As String                                                     'non-boolean search. 1 element
      T(0) = LCase$(xTerm)                                                     'contains entire search string
   Else
      While InStr(xTerm$, "  ") : Replace "  " With " " In xTerm$ : Wend       'remove double spaces
      xTerm$ = Trim$(xTerm$)                                                   'remove end spaces
      ReDim T(ParseCount(xTerm$, " ")-1) As String                             'create array of terms
      Parse xTerm$, T(), " "                                                   'single word in each array element
   End If
End Sub

Sub LoadListViewFromFilesArray
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long, fName$, temp$, UST,LST As SystemTime
    SendMessage GetDlgItem(hDlg,%IDC_ListView), %WM_SetRedraw, %False, 0
    LVActive = 1
    ListView Set Header hDlg, %IDC_ListView, 4, IIf$(ExactFileSize,"Bytes","KB")
    For i = 1 To FileCount
       fName$ = Files(i).FileName
       'add the file to ListView
       ListView Insert Item hDlg, %IDC_ListView, i, 0, PathName$(Namex, fName$)
       ListView Set Text hDlg, %IDC_ListView, i, 2, fName$

       'matching file was found. Now add additional information to ListView about the file
       FileTimeToSystemTime(ByVal VarPtr(Files(i).LastWriteTime),UST)  'UTC
       SystemTimeToTzSpecificLocalTime(ByVal %Null, UST,LST)              'Local
       ListView Set Text hDlg, %IDC_ListView, i,3, SortFormatST(LST,0)

       temp$ = Str$(Files(i).FileSizeHigh * &H100000000 + Files(i).FileSizeLow)
       If ExactFileSize Then
           ListView Set Text hDlg, %IDC_ListView, i,4, Format$(Val(temp$),"#,###,###,###") ' + "    "
       Else
           If Val(temp$) < 1024 Then temp$ = "1024"
           ListView Set Text hDlg, %IDC_ListView, i,4, Format$(Val(temp$)/1024,"#,###,###") ' + "    "
       End If

       ListView Set Text hDlg, %IDC_Listview, i,5, Trim$(Trim$(PathName$(Extn,Files(i).FileName),"."))

       ListView_SetCheckState hListView, i-1, %True
   Next i
   LVActive = 0
   SendMessage GetDlgItem(hDlg,%IDC_ListView), %WM_SetRedraw, %True, 0
End Sub

Function SortFormatST(ByVal ST As SystemTime, Optional ByVal Flag24 As Long) As String   '1=24 hr time  0=12 hr time
    If Debug Then cPrint LCase$(FuncName$)
    Flag24 = 1
    If Flag24 Then
        '24 hour format
        Function = Format$(ST.wYear,"00") + "-" + Format$(ST.wMonth,"00") + "-" + Format$(ST.wDay,"00") + " " _
                 + Format$(ST.wHour,"00") + ":" + Format$(ST.wMinute,"00") + ":" + Format$(ST.wSecond,"00")
    Else
        '12 hour format
        Function = Format$(ST.wYear,"00") + "-" + Format$(ST.wMonth,"00") + "-" + Format$(ST.wDay,"00") + "  " _
                 + Format$(IIf(ST.wHour >=0 And St.wHour <=11, IIf(ST.wHour=0,12,ST.wHour), ST.wHour-12),"00") + ":" _
                 + Format$(ST.wMinute,"00") + ":" + Format$(ST.wSecond,"00") _
                 + IIf$(ST.wHour >=0 And St.wHour <=11, " AM"," PM")

    End If
End Function

Function FormatST(ByVal ST As SystemTime, Optional ByVal Flag24 As Long) As String   '1=24 hr time  0=12 hr time
    If Debug Then cPrint LCase$(FuncName$)
    If Flag24 Then
        '24 hour format
        Function = Format$(ST.wMonth,"00") + "-" + Format$(ST.wDay,"00") + "-" + Format$(ST.wYear,"00") + " " _
                 + Format$(ST.wHour,"00") + ":" + Format$(ST.wMinute,"00") + ":" + Format$(ST.wSecond,"00")
    Else
        '12 hour format
        Function = Format$(ST.wMonth,"00") + "-" + Format$(ST.wDay,"00") + "-" + Format$(ST.wYear,"00") + "  " _
                 + Format$(IIf(ST.wHour >=0 And St.wHour <=11, IIf(ST.wHour=0,12,ST.wHour), ST.wHour-12),"00") + ":" _
                 + Format$(ST.wMinute,"00") + ":" + Format$(ST.wSecond,"00") _
                 + IIf$(ST.wHour >=0 And St.wHour <=11, " AM"," PM")

    End If
End Function

Sub CreateMergeFile
   If Debug Then cPrint LCase$(FuncName$)
   Local iCount,iResult,FilesMerged, FilesIgnored As Long, fName$, result$, fText$, tempz As AsciiZ * %Max_Path, temp$

   'proceed only if there are any files in the ListView
   ListView Get Count hDlg, %IDC_ListView To iCount
   If iCount = 0 Then
       MsgBoxX "No files selected!", %MB_Ok + %MB_IconExclamation, "Create Merge File"
       Exit Sub
   End If

   MousePtr 11
   QueryPerformanceCounter qStart

   'update list of allow files to merge (text files)
   UpdateTextExt

   'remove mergefile.txt, if it exists
   If Len(Dir$(Exe.Path$ + "mergefile.txt")) Then Kill Exe.Path$ + "mergefile.txt"

   'get text from each file in ListView
   temp$ = ""
   For iCount = 1 To iCount
       iResult = ListView_GetCheckState(hListView,iCount-1)
       If iResult Then
           ListView Get Text hDlg, %IDC_ListView, iCount, 2 To fName$
           If InStr(TextExt, PathName$(Extn,fName$)) = 0 Then
               Incr FilesIgnored
               Iterate For 'cannot merge non-text files
           End If
           If Len(Dir$(fName$)) And Len(fName$) Then
              Incr FilesMerged
              Open fName$ For Binary As #1
              Get$ #1, Lof(1), fText$
              If LineNumbers Then fText$ = AddLineNumbers(fText$)
              If Dividers Then
                 result$ = Build$(result$,$CrLf,CustomDivider,"   ",fName$," ",temp$,$CrLf,fText$)
              Else
                 result$ = Build$(result$,$CrLf,fText$)
              End If
              Close #1
           End If
       End If
   Next iCount

   'put results into merge file, if not empty string
   Open Exe.Path$ + "mergefile.txt" For Output As #5
   Print #5, LTrim$(result$, $CrLf)
   Close #5

   QueryPerformanceCounter qStop

   'alert user if result is empty
   If Len(result$) = 0 Then
       Control Set Text hDlg, %IDC_RichEdit, "<merge file has no content>"
       Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, "  Lines: 0    Chars: 0"
       Statusbar Set Text hDlg, %IDC_Statusbar, 2, 0, "Files Merged: " + Str$(FilesMerged) + "      " + "Non-Text Files Ignored: " + Str$(FilesIgnored) + "      " + Format$((qStop-qStart)/qFreq,"###.000") & " seconds"
       Dialog Set Text hDlg, $Ver + "   " + Exe.Path$ + "mergefile.txt"
       MousePtr 1
       Beep
   Else
       'put results into RichEdit
       Control Set Text hDlg, %IDC_RichEdit, Mid$(result$,3)
       Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, "  Lines: " + Format$(ParseCount(result$,$CrLf),"###,###,###") + "     Chars: " + Format$(Len(result$)-2,"###,###,###")
       Statusbar Set Text hDlg, %IDC_Statusbar, 2, 0, "Files Merged: " + Str$(FilesMerged) + "      " + "Non-Text Files Ignored: " + Str$(FilesIgnored) + "      " + Format$((qStop-qStart)/qFreq,"###.000") & " seconds"
       Dialog Set Text hDlg, $Ver + "   " + Exe.Path$ + "mergefile.txt"
       'open merge file
       If AutoOpenMerge Then
           tempz = Exe.Path$ + "mergefile.txt"
           If IsFile(tempZ) Then
               iResult = ShellExecute(hDlg, "Open", tempz, $Nul, $Nul, %SW_ShowNormal)
           Else
               MsgBoxX "Merge file not found!", %MB_Ok + %MB_IconExclamation,"Open Merge File"
           End If
       End If
   End If
   MousePtr 1
End Sub

Sub CreateGBSFile
   If Debug Then cPrint LCase$(FuncName$)
   Local i,j,iCount,iFilesAdded, CurrentFolderLevel As Long, fName$, fPath$, temp$, oldPath$, SampleFile$, tempZ As AsciiZ * %Max_Path

   ComboBox Get Text hDlg, %IDC_ComboFolders To sFolder
'   sFolder = RTrim$(sFolder,"\")
   If Right$(sFolder,1) <> "\" Then sFolder = sFolder + "\"

   ListView Get Count hDlg, %IDC_ListView To iCount
   If iCount = 0 Then Exit Sub

   SampleFile$ = Exe.Path$ + "gbsearch.gbs"
   If Len(Dir$(SampleFile$)) Then Kill SampleFile$    'kill pre-existing copy of output file

   UpdateTextExt

   'Open output file and add root information
   Open SampleFile$ For Output As #1
   Print #1, "0" + $CrLf + "PowerBASIC Source Code" + $CrLf + "PowerBASIC"

   'Add each file
   For i = 1 To iCount
      ListView Get Text hDlg, %IDC_ListView, i,2 To fName$
      If InStr(TextExt, PathName$(Extn,fName$)) = 0 Then Iterate For

      If ListView_GetCheckState(hListView,i-1) Then
          Replace sFolder With "" In fName$
          fPath$ = RTrim$(PathName$(Path, fName$),"\")

          'read the source file
          Open sFolder + fName$ For Binary As #2
          Get$ #2, Lof(2), temp$
          Replace Chr$(0) With $CrLf In temp$
          Close #2
          Incr iFilesAdded

          If Len(fPath$) Then
              'ensure that parent levels have been written
              CurrentFolderLevel = ParseCount(fPath$,"\")       'highest folder level
              'print folder (parent) entries
              For j = 1 To CurrentFolderLevel
                 If Parse$(fPath$,"\",j) <> Parse$(oldPath$,"\",j) Then 'print the level
                    Print #1, "++-" + "-;;"
                    Print #1, Str$(j)
                    Print #1, Parse$(fPath$,"\",j)
                 End If
              Next j
              'add the source file to SampleFile
              Print #1, "++-" + "-;;"
              Print #1, CurrentFolderLevel + 1             'one more than folder level
              Print #1, PathName$(Namex, fName$)     'filename is line 1 of each snippet
              Print #1, "'Compilable Example:"
              Print #1, temp$
          Else
              'add the source file to SampleFile
              Print #1, "++-" + "-;;"
              Print #1, "1"
              Print #1, PathName$(Namex, fName$)     'filename is line 1 of each snippet
              Print #1, "'Compilable Example:"
              Print #1, temp$
          End If

          oldPath$ = fPath$
      End If
   Next i

   Close #1   'done

   Statusbar Set Text hDlg, %IDC_Statusbar, 2, 0, "gbSnippets Library Created.  Files merged: " + Str$(iFilesAdded)

   'open GBS file
   tempz = SampleFile$
   i = ShellExecute(hDlg, "Open", tempz, $Nul, $Nul, %SW_ShowNormal)
'  i = Shell ("Notepad " + SampleFile$, 1)  'opens Notepad, does not wait for it to close
End Sub

Sub SetUndo(temp$,Flag As Long)
    If Debug Then cPrint LCase$(FuncName$)
    UndoText = temp$
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Undo, IIf(Flag,%TBState_Enabled,%TBState_Disabled)
End Sub

Sub DisplayChildren (hParent As Dword)
   If Debug Then cPrint LCase$(FuncName$)
   Local hChild, hTemp As Dword
   Local ChildDIR, ParentDIR, temp As String
   Local FullPath As String

   'get text of parent node that is is expanding
   Treeview Get Text hDlg, %IDC_TreeView, hParent To ParentDIR
   ParentDIR = Trim$(ParentDIR, "\")           'this turns c:\ into c:

   'remove all children to ensure currency of display and directory structure
   Do
      Treeview Get Child hDlg, %IDC_TreeView, hParent To hChild
      If hChild Then Treeview Delete hDlg, %IDC_TreeView, hChild
   Loop While hChild

   'add nodes for each subfolder
   ChildDir = Dir$(FullTreePath(hParent) + "\*.*", Only %SubDir)
   While Len(ChildDIR)
      Treeview Insert Item hDlg, %IDC_TreeView, hParent, %TVI_Last, 0, 0, ChildDIR To hTemp
      ChildDIR = Dir$
   Wend

   'add dummy child to each tree element whose folder has subfolders (causes TreeView to display + sign)
   Treeview Get Child hDlg, %IDC_TreeView, hParent To hChild
   While hChild
      FullPath = FullTreePath(hChild)
      temp = Dir$(FullPath + "\*.*", Only %SubDir)
      If Len(temp) Then Treeview Insert Item hDlg, %IDC_TreeView, hChild, %TVI_Last, 0, 0, "n/a" To hTemp
      Treeview Get Next hDlg, %IDC_TreeView, hChild To hChild
   Wend
End Sub

Function FullTreePath(ByVal hNode As Dword) As String
   If Debug Then cPrint LCase$(FuncName$)
   'get full directory path for hNode
   Local FullPath, temp As String
   Do
      Treeview Get Text hDlg, %IDC_TreeView, hNode To temp
      FullPath = "\" + temp + FullPath
      Treeview Get Parent hDlg, %IDC_TreeView, hNode To hNode
   Loop Until hNode = 0
   temp$ = LTrim$(FullPath, "\")
   Replace ":\\" With ":\" In temp$
'   If Right$(temp$,1) <> "\" Then temp$ = temp$ + "\"   'FullTreePath always ends in \
   Function = temp$
End Function


Sub DisplayFileViewer
   If Debug Then cPrint LCase$(FuncName$)
    Local iResult As Long
    If ViewFile Then
        Control Show State hDlg, %IDC_RichEdit, %SW_Show
        ListView Get Select hDlg, %IDC_ListView To iResult
        If iResult = 0 Then
            SelectedFile = ""
            Control Set Text hDlg, %IDC_RichEdit, ""
        Else
            ListView Get Text hDlg, %IDC_ListView, iResult, 2  To SelectedFile
            If Len(Dir$(SelectedFile)) And Len(SelectedFile) Then LoadSelectedFile
        End If
    Else
        Control Show State hDlg, %IDC_RichEdit, %SW_Hide
    End If
End Sub


'===ListView Context Menu Utilities=======================================================
Sub DisplaySummary
   If Debug Then cPrint LCase$(FuncName$)
   Local cCount,iCount,iResult,i, iTextFiles, iNonTextFiles As Long, fName$
   ListView Get Count hDlg, %IDC_ListView To iCount

   For i = 1 To iCount
       ListView Get Text hDlg, %IDC_ListView, i, 2  To fName$
       If InStr(TextExt, PathName$(Extn,fName$)) = 0 Then
           Incr iNonTextFiles
       Else
           Incr iTextFiles
       End If
       iResult = ListView_GetCheckState(hListView,i-1)
       If iResult Then Incr cCount
   Next i
   MsgBoxX Str$(iCount) + " Files" + $CrLf + Str$(cCount) + " Selected" + _
           $CrLf + Str$(iTextFiles) + " Text Files" + $CrLf + Str$(iNonTextFiles) + " Non-Text Files", %MB_Ok + %MB_IconInformation, "Results Summary"
End Sub

Sub RemoveSelectedFile
   If Debug Then cPrint LCase$(FuncName$)
   Local iResult,iCount As Long
   ListView Get Select hDlg, %IDC_ListView To iResult
   ListView Delete Item hDlg, %IDC_ListView, iResult

   ListView Get Count hDlg, %IDC_ListView To iCount
   If iCount Then ListView Select hDlg, %IDC_ListView, IIf(iResult>1,iResult-1,iResult)
End Sub

Sub DeleteSelectedFile
   If Debug Then cPrint LCase$(FuncName$)
   Local temp$, iResult, iCount As Long

   If AllowFileDeletion = 0 Then MsgBoxX "File deletion currently not allowed. Check settings!", %MB_Ok + %MB_IconExclamation, "Delete Selected File" : Exit Sub

   ListView Get Select hDlg, %IDC_ListView To iResult
   If iResult = 0 Then MsgBoxX "No file selected!", %MB_Ok + %MB_IconExclamation, "Delete Selected File" : Exit Sub
   ListView Get Text hDlg, %IDC_ListView, iResult, 2  To SelectedFile

   If Len(Dir$(SelectedFile)) = 0 Then
       MsgBoxX("File not found!" + $CrLf + SelectedFile, %MB_Ok Or %MB_IconExclamation, "Delete Selected File")
       Exit Sub
   End If

   temp$ = "File to be deleted:" + $CrLf + SelectedFile + $CrLf + $CrLf + "Are you sure?"
   If MsgBoxX (temp$, %MB_OkCancel Or %MB_IconQuestion, "Delete File") = %IdOk Then
       Kill SelectedFile
       ListView Delete Item hDlg, %IDC_ListView, iResult
       ListView Get Count hDlg, %IDC_ListView To iCount
       If iCount = 0 Then Exit If
       ListView Select hDlg, %IDC_ListView, IIf(iResult>1,iResult-1,iResult)
   End If
End Sub

Sub DeleteCheckedFiles
   If Debug Then cPrint LCase$(FuncName$)
   Local temp$, i,iResult,iCount,iFileCount As Long

   If AllowFileDeletion = 0 Then MsgBoxX "File deletion currently not allowed. Check settings!", %MB_Ok + %MB_IconExclamation, "Delete Checked Files" : Exit Sub

   'verify there are files to delete
   ListView Get Count hDlg, %IDC_ListView To iCount
   For i = 1 To iCount
      iResult = ListView_GetCheckState(hListView,i-1)
      If iResult Then Incr iFileCount
   Next i
   If iFileCount = 0 Then MsgBoxX "No files checked! No files will be deleted.", %MB_Ok + %MB_IconExclamation, "Delete Checked Files" : Exit Sub

   temp$ = Str$(iFileCount) + " file(s) to be deleted:" + $CrLf + $CrLf + $CrLf + "Are you sure?"
   If MsgBoxX (temp$, %MB_OkCancel Or %MB_IconQuestion, "Delete File") = %IdOk Then
       For i = iCount To 1 Step -1
          If ListView_GetCheckState(hListView,i-1) Then
             ListView Get Text hDlg, %IDC_ListView, i,2 To temp$
             Kill temp$
             ListView Delete Item hDlg, %IDC_ListView, i
          End If
       Next i
   End If
End Sub

Sub CopyList
   If Debug Then cPrint LCase$(FuncName$)
   Local i, iCount As Long, temp$, result$
   Clipboard Reset
   ListView Get Count hDlg, %IDC_ListView To iCount
   If iCount = 0 Then
       MsgBoxX "File list is empty!", %MB_Ok + %MB_IconExclamation, "Copy File List to Clipboard"
       Exit Sub
   End If
   For i = 1 To iCount
       ListView Get Text hDlg, %IDC_ListView, i,2 To temp$
       result$ = Build$(result$,$CrLf,temp$)
   Next i
   result$ = Trim$(result$,$CrLf)
   Clipboard Set Text result$
End Sub

Sub CopyChecked
   If Debug Then cPrint LCase$(FuncName$)
    Local i,iCount As Long, temp$
    ListView Get Count hDlg, %IDC_ListView To iCount
    For i = 1 To iCount
       If ListView_GetCheckState(hListView,i-1) Then
          ListView Get Text hDlg, %IDC_ListView, i, 2  To temp$
          FileCopy temp$, Exe.Path$ + "working\" + PathName$(Namex,temp$)
       End If
    Next i
End Sub

Sub OpenWorking
    If Debug Then cPrint LCase$(FuncName$)
    Local iResult As Long, tempz As AsciiZ * %Max_Path
    tempz = Exe.Path$ + "working\"
    iResult = ShellExecute(hDlg, "Open", tempz, $Nul, $Nul, %SW_ShowNormal)
End Sub

Sub CheckDuplicates
   If Debug Then cPrint LCase$(FuncName$)
   Local ftext$, temp$, i,iCount,iResult,iMatch As Long
   MousePtr 11

   ListView Get Count hDlg, %IDC_ListView To iCount
   ListView Get Select hDlg, %IDC_ListView To iResult
   ListView Get Text hDlg, %IDC_ListView, iResult, 2 To ftext$
   If Len(Dir$(fText$))=0 Or  Len(fText$)=0 Then
      MsgBoxX "Invalid file selection!", %MB_Ok + %MB_IconExclamation, "Check Duplicates"
      Exit Sub
   End If

   Open ftext$ For Binary As #1
   Get$ #1, Lof(1), ftext$
   Close #1

   For i = 1 To iCount
      'get text of each file
      ListView Get Text hDlg, %IDC_ListView, i, 2 To temp$
      Open temp$ For Binary As #1
      Get$ #1, Lof(1), temp$
      Close #1
      If ftext$ = temp$ Then
         ListView_SetCheckState hListView, i-1, %True
         Incr iMatch
      Else
         ListView_SetCheckState hListView, i-1, %False
      End If
   Next i
   Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, "Duplicates found: " + Str$(iMatch)
   MousePtr 1
End Sub

Sub CompareFiles
   If Debug Then cPrint LCase$(FuncName$)
    Local texta$, textb$, filea$, fileb$, temp$, i, iCount, Flag, iResult As Long
    'get 1st two marked files
    ListView Get Count hDlg, %IDC_ListView To iCount
    For i = 1 To iCount
       iResult = ListView_GetCheckState(hListView,i-1)
       If iResult Then
          If Flag = 1 Then ListView Get Text hDlg, %IDC_ListView, i, 2  To fileb$ : Flag = 2 : Exit For
          If Flag = 0 Then ListView Get Text hDlg, %IDC_ListView, i, 2  To filea$ : Flag = 1
       End If
    Next i
    If Flag < 2 Then
        MsgBoxX "Check files to compare!", %MB_Ok + %MB_IconExclamation, "Compare Files"
        Exit Sub
    End If

    If ViewFile = 0 Then ViewFile = 1 : DisplayFileViewer : ResizeWindow

    Open filea$ For Binary As #1 : Get$ #1, Lof(1), texta$ : Close #1  'reuse file name to hold file text
    Open fileb$ For Binary As #1 : Get$ #1, Lof(1), textb$ : Close #1
    If texta$ = textb$ Then
        MsgBoxX "Files are identical!", %MB_Ok + %MB_IconInformation, "File Comparison"
    Else
        StrikeAOutDifferences texta$, textb$
        'remove starting line
        Local P As CharRange
        P.cpmin = 1 : P.cpmax = 2
        iResult = SendMessage(hRichEdit, %EM_ExSetSel, 0, VarPtr(P))       'length of specified line
        temp$ = ""
        iResult = SendMessage(hRichEdit, %EM_ReplaceSel, %False, StrPtr(temp$))  'replace
    End If
End Sub

Function StrikeAOutDifferences(txt1$, txt2$) As Integer
   If Debug Then cPrint LCase$(FuncName$)
   ' Costs for adding or replacing lines.
   Dim lines1() As String, lines2() As String
   Dim len1 As Integer, len2 As Integer
   Dim distances() As Integer
   Dim moves() As Long   'MoveType
   Dim i1 As Integer, i2 As Integer
   Dim line1 As String, line2 As String
   Dim dist_repl As Integer
   Dim dist_add1 As Integer
   Dim dist_add2 As Integer
   Dim move_sequence() As Long
   Dim num_moves As Integer
   Dim i As Integer
   Local ComparisonChangesOnly&

   ' Split the strings into arrays of lines.
   ' We add a vbCrLf at the front so we get an
   ' extra blank string in array entry 0.
   Dim lines1 (1 To ParseCount(txt1$,$CrLf))
   Dim lines2 (1 To ParseCount(txt2$,$CrLf))
   Parse txt1$, lines1(), $CrLf    'Split(vbCrLf & txt1, vbCrLf)
   Parse txt2$, lines2(), $CrLf    'Split(vbCrLf & txt2, vbCrLf)

   ' Allocate space for the distances
   ' and moves arrays.
   len1 = UBound(lines1)
   len2 = UBound(lines2)
   ReDim distances(0 To len1, 0 To len2)
   ReDim moves(0 To len1, 0 To len2)

   ' Initialize the arrays.
   moves(0, 0) = %move_NoChange
   For i1 = 1 To len1
      distances(i1, 0) = distances(i1 - 1, 0) + %COST_ADD1
      moves(i1, 0) = %move_Add1
   Next i1
   For i2 = 1 To len2
      distances(0, i2) = distances(0, i2 - 1) + %COST_ADD2
      moves(0, i2) = %move_Add2
   Next i2

   ' Fill in the rest of the arrays.
   For i1 = 1 To len1
      line1 = lines1(i1)
      For i2 = 1 To len2
         line2 = lines2(i2)

         ' See how much it would cost to start
         ' from the (i1 - 1, i2 - 1) entry.
         If line1 = line2 Then
            dist_repl = distances(i1 - 1, i2 - 1)
         Else
            dist_repl = distances(i1 - 1, i2 - 1) + %COST_REPL
         End If

         ' See how much it would cost to start
         ' from the (i1 - 1, i2) and (i1, i2 - 1)
         ' entries.
         dist_add1 = distances(i1 - 1, i2) + %COST_ADD1
         dist_add2 = distances(i1, i2 - 1) + %COST_ADD2

         ' See which method is cheapest.
         If (dist_repl <= dist_add1) And (dist_repl <= dist_add2) Then
            distances(i1, i2) = dist_repl
            If line1 = line2 Then
               moves(i1, i2) = %move_NoChange
            Else
               moves(i1, i2) = %move_Replace
            End If
         ElseIf (dist_add1 <= dist_repl) And (dist_add1 <= dist_add2) Then
            distances(i1, i2) = dist_add1
            moves(i1, i2) = %move_Add1
         Else
            distances(i1, i2) = dist_add2
            moves(i1, i2) = %move_Add2
         End If
      Next i2
   Next i1

   ' Set the return edit distance value.
   'EditDistanceLines = distances(len1, len2)
   StrikeAOutDifferences = distances(len1,len2)

   ' Make a list of the moves we took
   ' (in reverse order).
   i1 = len1
   i2 = len2
   Do While (i1 > 0) Or (i2 > 0)
      ' Save the move.
      num_moves = num_moves + 1
      ReDim Preserve move_sequence(1 To num_moves)
      move_sequence(num_moves) = moves(i1, i2)

      ' Go to the previous position in the array.
      Select Case moves(i1, i2)
         Case %move_NoChange
            i1 = i1 - 1
            i2 = i2 - 1
         Case %move_Replace
            i1 = i1 - 1
            i2 = i2 - 1
         Case %move_Add1
            i1 = i1 - 1
         Case %move_Add2
            i2 = i2 - 1
      End Select
   Loop

   ' Use the moves to build the result string.
   i1 = 1
   i2 = 1

   Control Set Text hDlg, %IDC_RichEdit, ""   'rchDifference.Text = ""
   For i = num_moves To 1 Step -1
      Select Case move_sequence(i)
         Case %move_Add1
            StrikeBOutAddToEndAndSelect $CrLf + lines1(i1)
            StrikeOutSetRichTextColor %Red     'set format of selection + StrikeThru
            i1 = i1 + 1
         Case %move_Add2
            StrikeBOutAddToEndAndSelect $CrLf + lines2(i2)
            StrikeOutSetRichTextColor %Blue     'set format of selection
            i2 = i2 + 1
         Case %move_Replace
            StrikeBOutAddToEndAndSelect $CrLf + lines1(i1)
            StrikeOutSetRichTextColor %Red     'set format of selection + StrikeThru

            StrikeBOutAddToEndAndSelect $CrLf + lines2(i2)
            StrikeOutSetRichTextColor %Blue     'set format of selection
            i1 = i1 + 1
            i2 = i2 + 1
         Case %move_NoChange
            If IsFalse(ComparisonChangesOnly) Then
               StrikeBOutAddToEndAndSelect $CrLf + lines2(i2)
               StrikeOutSetRichTextColor %Black     'set format of selection
               i1 = i1 + 1
               i2 = i2 + 1
            End If
      End Select
   Next i
End Function

Function StrikeBOutAddToEndAndSelect(ByVal buf$) As Long
   If Debug Then cPrint LCase$(FuncName$)
   Local D As GetTextLengthEX, iTextLength&, iResult&, P As CharRange
   'get length of all text
   D.flags = %GTL_Default
   iTextLength& = SendMessage(hRichEdit, %EM_GetTextLengthEX, VarPtr(D),0)

   'put cursor at end of control
   P.cpmin = iTextLength& : P.cpmax = P.cpmin
   SendMessage hRichEdit, %EM_EXSetSel, 0, VarPtr(P) To iResult&            'put cursor at end of control

   'put text at cursor
   SendMessage(hRichEdit, %EM_ReplaceSel, %True, StrPtr(buf$))   'only replace if selection exists.

   'select last line
   P.cpmin = iTextLength& + 2 : P.cpmax = P.cpmin + Len(buf$)
   SendMessage hRichEdit, %EM_EXSetSel, 0, VarPtr(P) To iResult&

End Function

Function StrikeOutSetRichTextColor( ByVal NewColor As Long) As Long
   If Debug Then cPrint LCase$(FuncName$)
   ' setRichTextColor sets the textcolor for selected text in a Richedit control.
   Local cf As CHARFORMAT
   cf.cbSize      = Len(cf)       'Length of structure
   cf.dwMask      = %CFM_COLOR Or %CFM_STRIKEOUT  'Set mask to colors only
   If NewColor = %Red Then cf.dwEffects   = %CFE_StrikeOut Else cf.dwEffects   = 0
   cf.crTextColor = NewColor      'Set the new color value
   SendMessage(hRichEdit, %EM_SETCHARFORMAT, %SCF_SELECTION, VarPtr(cf))
End Function

Sub OpenCheckedDefaultClient    'open all checked files in default client
   If Debug Then cPrint LCase$(FuncName$)
   Local i,iResult, iCount As Long, temp$
   ListView Get Count hDlg, %IDC_ListView To iCount
   If iCount = 0 Then
       MsgBoxX "File list is empty!", %MB_Ok + %MB_IconExclamation, "Copy File List to Clipboard"
       Exit Sub
   End If
   For i = 1 To iCount
       If ListView_GetCheckState(hListView,i-1) Then
          ListView Get Text hDlg, %IDC_ListView, i,2 To temp$
          iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
       End If
   Next i
End Sub

Sub OpenSelectedSpecifiedClient
   If Debug Then cPrint LCase$(FuncName$)
   Local iResult As Long, temp$
   ListView Get Select hDlg, %IDC_ListView To iResult
   If iResult Then
      ListView Get Text hDlg, %IDC_ListView, iResult, 2  To temp$
      iResult  = Shell (SpecifiedClient + " " + temp$, 1)  'does not wait for it to close
   Else
      MsgBoxX "No file selected!", %MB_Ok + %MB_IconExclamation, "Open Selected File (In Specified Client)"
   End If
End Sub

Sub OpenCheckedSpecifiedClient
   If Debug Then cPrint LCase$(FuncName$)
   Local i,iResult, iCount As Long, temp$
   ListView Get Count hDlg, %IDC_ListView To iCount
   If iCount = 0 Then
       MsgBoxX "File list is empty!", %MB_Ok + %MB_IconExclamation, "Copy File List to Clipboard"
       Exit Sub
   End If
   For i = 1 To iCount
       If ListView_GetCheckState(hListView,i-1) Then
          ListView Get Text hDlg, %IDC_ListView, i,2 To temp$
         iResult  = Shell (SpecifiedClient + " " + temp$, 1)  'does not wait for it to close
       End If
   Next i
End Sub

Sub SelectClient
   If Debug Then cPrint LCase$(FuncName$)
   Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
   title$ = "Select Specified Editor"    'caption title. if "", then "Open" is displayed
    filter$ = "Editor" + $Nul + "*.exe" + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
    startfolder$ = SpecifiedClient    'initial folder to be displayed
    startfile$ = SpecifiedClient      'name to be used as initial selection
    defaultext$ = "exe"                 'default extension to append to selection if user does not enter it
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, _
                              defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
        SpecifiedClient = filevar$
    Else
        'no action ESC or cancel
    End If
End Sub

Sub ExportCSV
   If Debug Then cPrint LCase$(FuncName$)
   Local tempName,tempPath,tempDate,tempSize,tempExt As String
   Local i, iResult,iCount As Long, result$
   Clipboard Reset
   ListView Get Count hDlg, %IDC_ListView To iCount
   If iCount = 0 Then
       MsgBoxX "File list is empty!", %MB_Ok + %MB_IconExclamation, "Copy File List to Clipboard"
       Exit Sub
   End If
   For i = 1 To iCount
       ListView Get Text hDlg, %IDC_ListView, i,1 To tempName : tempName = Trim$(tempName)
       ListView Get Text hDlg, %IDC_ListView, i,2 To tempPath : tempPath = Trim$(tempPath)
       ListView Get Text hDlg, %IDC_ListView, i,3 To tempDate : tempDate = Trim$(tempDate)
       ListView Get Text hDlg, %IDC_ListView, i,4 To tempSize : tempSize = Trim$(tempSize)
       ListView Get Text hDlg, %IDC_ListView, i,5 To tempExt  : tempExt  = Trim$(tempExt)
       result$ = Build$(result$,$CrLf,$Dq,tempName,$Dq,",",$Dq,tempPath,$Dq,",",$Dq,tempDate,$Dq,",",$Dq,tempSize,$Dq,",",$Dq,tempExt,$Dq)
   Next i
   result$ = Trim$(result$,$CrLf)
   Open Exe.Path$ + "gbsearch.csv" For Output As #1
   Print #1, result$
   Close #1
   iResult  = Shell ("Notepad " + Exe.Path$ + "gbsearch.csv", 1)  'opens Notepad, does not wait for it to close
End Sub

Sub ExportTXT(Flag As Long)
   If Debug Then cPrint LCase$(FuncName$)
   Local tempName,tempPath,tempDate,tempSize,tempExt As String
   Local i, iResult,iCount As Long, result$
   Clipboard Reset
   ListView Get Count hDlg, %IDC_ListView To iCount
   If iCount = 0 Then
       MsgBoxX "File list is empty!", %MB_Ok + %MB_IconExclamation, "Copy File List to Clipboard"
       Exit Sub
   End If
   For i = 1 To iCount
       If Flag Then
           ListView Get Text hDlg, %IDC_ListView, i,1 To tempName : tempName = Trim$(tempName)
           ListView Get Text hDlg, %IDC_ListView, i,2 To tempPath : tempPath = Trim$(tempPath)
           ListView Get Text hDlg, %IDC_ListView, i,3 To tempDate : tempDate = Trim$(tempDate)
           ListView Get Text hDlg, %IDC_ListView, i,4 To tempSize : tempSize = Trim$(tempSize)
           ListView Get Text hDlg, %IDC_ListView, i,5 To tempExt  : tempExt  = Trim$(tempExt)
           result$ = Build$(result$,$CrLf,tempName,$Spc,TxtDivider,$Spc,tempPath,$Spc,TxtDivider,$Spc,tempDate,$Spc, TxtDivider,$Spc,tempSize,$Spc,TxtDivider,$Spc,tempExt)
       Else
           ListView Get Text hDlg, %IDC_ListView, i,2 To tempPath : tempPath = Trim$(tempPath)
           result$ = Build$(result$,$CrLf,tempPath)
       End If
   Next i
   result$ = Trim$(result$,$CrLf)
   Open Exe.Path$ + "gbsearch.txt" For Output As #1
   Print #1, result$
   Close #1
   iResult  = Shell ("Notepad " + Exe.Path$ + "gbsearch.txt", 1)  'opens Notepad, does not wait for it to close
End Sub

Sub ClearConsole
   If Debug Then cPrint LCase$(FuncName$)
   Local hWrittenChars As Long
   Local tConsoleInfo As CONSOLE_SCREEN_BUFFER_INFO
   GetConsoleScreenBufferInfo(hConsole, tConsoleInfo)
   FillConsoleOutputCharacter(hConsole, 32, tConsoleInfo.dwSize.x * tConsoleInfo.dwSize.y, Mak(Dword,0,0), hWrittenChars)
   SetConsoleCursorPosition(hConsole, Mak(Dword,0,0))
   Sleep 500   'time for cursor to move off ListView
End Sub

Sub CPrint (SOut As String)
   Static cWritten, iCount As Long
   If hConsole = 0 Then AllocConsole: hConsole = GetStdHandle(-11&)
   sOut = Format$(iCount,"000000  ") + sOut
   WriteConsole hConsole, ByCopy sOut + $CrLf, Len(sOut) + 2, cWritten, ByVal 0&
   Incr iCount
End Sub

'===Start of RichEdit Context Menu Utilities=======================================================

Sub RESummary
   If Debug Then cPrint LCase$(FuncName$)
   Dim T() As String
   Local iLineFeeds As Long, iTotalChars As Long, temp$, i As Long
   Local iLong As Long, iShort As Long, iLines As Long

   Control Get Text hDlg, %IDC_RichEdit To temp$
   If Len(temp$) = 0 Then
       MsgBoxX "Statistics:" & $CrLf & $CrLf & "None - file is empty", %MB_Ok + %MB_IconExclamation,"Set as Base Folder"
       Exit Sub
   End If
   iLines = ParseCount(temp$, $CrLf)
   Dim T(iLines) : Parse temp$, T(), $CrLf

   'look for longest/shortest lines
   iLong = 0 :  iShort = 99999999
   For i = 0 To UBound(T)
       If iLong < Len(T(i)) Then iLong = Len(T(i))
       If iShort > Len(T(i)) Then iShort = Len(T(i))
   Next i

   iLineFeeds = Tally(temp$, $CrLf)
   iTotalChars = Len(temp$)

   'set message
   temp$ = "Characters: " & Str$(iTotalChars) & $CrLf
   temp$ = temp$ & "Number lines: " & Str$(iLines) & $CrLf  & $CrLf
   temp$ = temp$ & "Shortest Line: " & Str$(iShort) & $CrLf
   temp$ = temp$ & "Longest line: " & Str$(iLong) & $CrLf
   temp$ = temp$ & "Average Line Length: " & Str$(Int(iTotalChars / iLines)) & $CrLf & $CrLf

   MsgBoxX temp$, %MB_Ok + %MB_IconInformation, "Content Summary"
End Sub

Sub HighlightTerms
   If Debug Then cPrint LCase$(FuncName$)
   Local i,iTopLine,iCharPos,iResult As Long, ft As FindTextEx, temp$
   Local Oldpd As CharRange, iEventMask&

   CreateSearchTermArray   ' T() will contain search terms

   'save position/eventmask, disable eventmask/redraw
   iTopLine = SendMessage(hRichEdit, %EM_GetFirstVisibleLine,0,0)       'visible line# at top of control
   iCharPos = SendMessage(hRichEdit, %EM_LineIndex, iTopLine, 0)       'position of 1st char in top line
   Oldpd.cpmin = iCharPos : Oldpd.cpmax = iCharPos
   iEventMask& = SendMessage(hRichEdit, %EM_GETEVENTMASK, 0, 0)   'save event mask
   SendMessage(hRichEdit, %EM_SETEVENTMASK, 0, 0)                 'disable event mask
   SendMessage(hRichEdit, %WM_SETREDRAW, 0, 0)                    'disable redraw

   For i = 0 To UBound(T)
      ft.chrg.cpmin = 0 : ft.chrg.cpmax = -1
      temp$ = T(i)
      ft.lpstrText = StrPtr(temp$)
      iResult = SendMessage(hRichEdit, %EM_FindTextEx, IIf(ExactCaseMatch,4,0), VarPtr(ft))      '4= %FR_MatchCase
      While iResult > -1
          SendMessage hRichEdit, %EM_EXSETSEL, 0, VarPtr(ft.chrgText)
          SetColor %Red, %Yellow
          ft.chrg.cpmin = ft.chrgText.cpmax : ft.chrg.cpmax = -1
          iResult = SendMessage(hRichEdit, %EM_FindTextEx, 0, VarPtr(ft))
      Wend
   Next I

   'restore position/eventmask, enable eventmask/redraw
   SendMessage(hRichEdit, %EM_EXSETSEL, 0, VarPtr(Oldpd))           'restore caret position
   SendMessage hRichEdit, %WM_SETREDRAW, 1, 0                       'turn on redraw
   InvalidateRect hRichEdit, ByVal %NULL, 0 : UpdateWindow hRichEdit  'refresh
   SendMessage(hRichEdit, %EM_SETEVENTMASK, 0, iEventMask&)              'enable event mask
End Sub

Function SetColor(REFG As Long, REBG As Long) As Long  'set format of selected text
   If Debug Then cPrint LCase$(FuncName$)
   Local cf As CHARFORMAT2
   cf.cbSize      = Len(cf)                   'Length of structure
   cf.dwMask      = %CFM_BackColor + %CFM_COLOR + %CFM_Bold    'Set mask to colors only
   cf.dwEffects   = %CFE_Bold                 'bold
   cf.crTextColor = REFG
   cf.crBackColor = REBG
   SendMessage(hRichEdit, %EM_SETCHARFORMAT, %SCF_SELECTION, VarPtr(cf))
End Function

Sub TurnOffTermHighlighting      'color all text to black/unbolded, with speed
   If Debug Then cPrint LCase$(FuncName$)
   Local iTopLine,iCharPos As Long
   Local cf As CharFormat2, Oldpd As CharRange, iEventMask&

   'save position/eventmask, disable eventmask/redraw
   iTopLine = SendMessage(hRichEdit, %EM_GetFirstVisibleLine,0,0)       'visible line# at top of control
   iCharPos = SendMessage(hRichEdit, %EM_LineIndex, iTopLine, 0)       'position of 1st char in top line
   Oldpd.cpmin = iCharPos : Oldpd.cpmax = iCharPos
   iEventMask& = SendMessage(hRichEdit, %EM_GETEVENTMASK, 0, 0)   'save event mask
   SendMessage(hRichEdit, %EM_SETEVENTMASK, 0, 0)                 'disable event mask
   SendMessage(hRichEdit, %WM_SETREDRAW, 0, 0)                    'disable redraw

   cf.cbSize      = Len(cf)                                   'Length of structure
   cf.dwMask      = %CFM_BackColor + %CFM_COLOR + %CFM_Bold                    'Set mask to colors only
   cf.dwEffects   = &H0                                       'normal (optional)
   cf.crTextColor = &H0                                       'Set black color value (optional)
   cf.crBackColor = %White
   SendMessage(hRichEdit, %EM_SETCHARFORMAT, %SCF_All, VarPtr(cf))

   'restore position/eventmask, enable eventmask/redraw
   SendMessage(hRichEdit, %EM_EXSETSEL, 0, VarPtr(Oldpd))           'restore caret position
   SendMessage hRichEdit, %WM_SETREDRAW, 1, 0                       'turn on redraw
   InvalidateRect hRichEdit, ByVal %NULL, 0 : UpdateWindow hRichEdit  'refresh
   SendMessage(hRichEdit, %EM_SETEVENTMASK, 0, iEventMask&)              'enable event mask
End Sub

Function GetMatchingLinesOnly(temp$) As String    '0=any term, 1=all terms
   If Debug Then cPrint LCase$(FuncName$)
   Local i,j,iCount As Long, result$

   CreateSearchTermArray                            ' T() will contain search terms

   Dim rLines(ParseCount(temp$,$CrLf)-1) As String   'rLines has original content
   Parse temp$, rLines(),$CrLf

   Dim testLines(UBound(rLines)) As String           'testLines has a copy upper/lower case for using to test
   Parse IIf$(ExactCaseMatch, temp$, LCase$(temp$)), testLines(), $CrLf

   For i = 0 To UBound(testLines)
       If Dividers And Left$(testLines(i),7) = "==++== " Then
          result$ = Build$(result$,$CrLf,rLines(i))
          Iterate For
       End If
       Select Case SearchMethod
          Case %AllTerms   ' &   - all terms in the line
             For j = 0 To UBound(T)
                If InStr(testLines(i),T(j)) = 0  Then Exit Select
             Next
             result$ = Build$(result$,$CrLf,rLines(i)) : Incr iCount
          Case %AnyTerms   ' |   - any term in the line
             For j = 0 To UBound(T)
                If InStr(testLines(i),T(j)) Then result$ = Build$(result$,$CrLf,rLines(i)) : Incr iCount : Exit For
             Next i
          Case %ExactString     ' - exact string is in the line
             For j = 0 To UBound(T)
                If InStr(testLines(i),T(j)) Then result$ = Build$(result$,$CrLf,rLines(i)) : Incr iCount : Exit For
             Next i
       End Select
    Next i
   Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, "Matching  Lines: " + Format$(iCount,"#,###,###")
   Function = Mid$(result$,3)
End Function

Sub SortContent(direction$)
   If Debug Then cPrint LCase$(FuncName$)
   Local temp$
   Control Get Text hDlg, %IDC_RichEdit To temp$    'put all lines in an array
   Dim D(ParseCount(temp$,$CrLf)-1) As String
   Parse temp$, D(), $CrLf
   If direction$ = "A" Then
       Array Sort D(), Ascend
   Else
       Array Sort D(), Descend
   End If
   Control Set Text hDlg, %IDC_RichEdit, Join$(D(),$CrLf)
End Sub

Sub SaveREFile(ByVal fName$)
   If Debug Then cPrint LCase$(FuncName$)
    Local temp$
    temp$ = "Content will be saved to: " + $CrLf + fName$ + $CrLf + $CrLf + "Are you sure?"
    If MsgBoxX (temp$, %MB_OkCancel Or %MB_IconQuestion, "Save File") = %IdOk Then
        Control Get Text hDlg, %IDC_RichEdit To temp$
        Open fName$ For Output As #1
        Print #1,temp$
        Close #1
    End If
End Sub

Sub SaveAsREFile
   If Debug Then cPrint LCase$(FuncName$)
    'save file to any location
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = ""                      'caption title. if "", then "Save As" is displayed
    startfolder$ = SelectedFile      'initial folder to be displayed
    filter$ = "*" + PathName$(Extn, SelectedFile) + $Nul
    startfile$ = SelectedFile        'name to be used as initial selection
    defaultext$ = Mid$(PathName$(Extn, SelectedFile),2)     'default extension to append to selection if user does not enter it
    flags& = %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt
    Display Savefile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then SaveREFile filevar$
End Sub

Sub ReloadMergeFile
    If Debug Then cPrint LCase$(FuncName$)
    Local temp$, tempZ As AsciiZ * %Max_Path
    tempz = Exe.Path$ + "mergefile.txt"
    If IsFile(tempZ) Then
        Open tempz For Binary As #1 : Get$ #1, Lof(1), temp$ : Close #1
        Control Set Text hDlg, %IDC_RichEdit, temp$
        Dialog Set Text hDlg, $Ver + "   " + Exe.Path$ + "mergefile.txt"
        SetUndo("",0)
        Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, "  Lines: " + Format$(ParseCount(temp$,$CrLf),"###,###,###") + "     Chars: " + Format$(Len(temp$),"###,###,###")
    Else
        MsgBoxX "Merge file not found!", %MB_Ok+%MB_IconExclamation, "Open Merge File"
    End If
End Sub

Function AddLineNumbers(temp$) As String
   If Debug Then cPrint LCase$(FuncName$)
    Local i,iCount As Long
    If Len(temp$) = 0 Then Exit Function
    Dim Lines(ParseCount(temp$,$CrLf)-1) As String
    Parse temp$, Lines(), $CrLf
    For i = 0 To UBound(Lines)
        If Left$(Lines(i),6) <> "==++==" Then
            Incr iCount
            Lines(i) = Format$(iCount,"000000") + "   " + Lines(i)
        Else
            iCount = 0
        End If
    Next i
    Function = Join$(Lines(),$CrLf)
End Function

Function RemoveLineNumbers(temp$) As String
   If Debug Then cPrint LCase$(FuncName$)
    Local i As Long
    If Len(temp$) = 0 Then Exit Function
    Dim Lines(ParseCount(temp$,$CrLf)-1) As String
    Parse temp$, Lines(), $CrLf
    For i = 0 To UBound(Lines)
        If Left$(Lines(i),6) <> "==++==" Then Lines(i) = Mid$(Lines(i), 10)
    Next i
    Function = Join$(Lines(),$CrLf)
End Function

Function RemoveDividers(temp$) As String
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long
    If Len(temp$) = 0 Then Exit Function
    Dim Lines(ParseCount(temp$,$CrLf)-1) As String
    Parse temp$, Lines(), $CrLf
    temp$ = ""
    For i = 0 To UBound(Lines)
        If Left$(Lines(i),7) <> "==++== " Then temp$ = Build$(temp$, $CrLf, Lines(i))
    Next i
    Function = Mid$(temp$,3)
End Function

Function RemoveBlankLines(temp$) As String
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long
    If Len(temp$) = 0 Then Exit Function
    Dim Lines(ParseCount(temp$,$CrLf)-1) As String
    Parse temp$, Lines(), $CrLf
    temp$ = ""
    For i = 0 To UBound(Lines)
        If Len(Trim$(Lines(i))) Then temp$ = Build$(temp$, $CrLf, Lines(i))
    Next i
    Function = Mid$(temp$,3)
End Function


'===Start of PowerBASIC Context Menu Utilities=======================================================

Function GetProcList(ProcListBuf$) As String
   If Debug Then cPrint LCase$(FuncName$)
   Local i, pCount As Long, tmp$, w1$, w2$, w3$, w4$, s1$, s2$, s3$, s4$, s12$, s123$
   Dim MUser(1000) As String
   Dim BufArray(ParseCount(ProcListBuf$,$CrLf)-1) As String   'break input string into an array
   Parse ProcListBuf$, BufArray(), $CrLf
   For i = 0 To UBound(BufArray)
      tmp$ = LTrim$(Retain$(BufArray(i), Any Chr$(65 To 90, 95, 97 To 122, 48 To 57, $Spc, "()=")))
      Replace Any "()" With "  " In tmp$
      While InStr(tmp$, "  ") : Replace "  " With " " In tmp$ : Wend  'remove all pairs of spaces
      w1$ = Parse$(tmp$," ",1) : w2$ = Parse$(tmp$," ",2) : w3$ = Parse$(tmp$," ",3) : w4$ = Parse$(tmp$," ",4)
      s1$ = LCase$(w1$) : s2$ = LCase$(w2$) : s3$ = LCase$(w3$) : s4$ = LCase$(w4$)
      s12$ = Build$(s1$, s2$)   :   s123$ = Build$(s1$, s2$, s3$)
      If s1$   = "sub"                           Then MUser(pCount) = w2$ : Incr pCount : Iterate For
      If s1$   = "function" And w2$ <> "="       Then MUser(pCount) = w2$ : Incr pCount : Iterate For
      If s12$  = "callback function"             Then MUser(pCount) = w3$ : Incr pCount : Iterate For

      If s1$   = "macro"                         Then MUser(pCount) = w2$ : Incr pCount : Iterate For
      If s12$  = "macro function"                Then MUser(pCount) = w3$ : Incr pCount : Iterate For

      If s12$  = "thread function"               Then MUser(pCount) = w3$ : Incr pCount : Iterate For

      If s1$   = "class"                         Then MUser(pCount) = w2$ : Incr pCount : Iterate For
      If s1$   = "method" And w2$ <> "="         Then MUser(pCount) = w2$ : Incr pCount : Iterate For
      If s12$  = "class method"                  Then MUser(pCount) = w3$ : Incr pCount : Iterate For
      If s12$  = "override method"               Then MUser(pCount) = w3$ : Incr pCount : Iterate For
      If s1$   = "interface"                     Then MUser(pCount) = w2$ : Incr pCount : Iterate For

      If s12$  = "property get"                  Then MUser(pCount) = w3$ : Incr pCount : Iterate For
      If s12$  = "property set"                  Then MUser(pCount) = w3$ : Incr pCount : Iterate For
      If s123$ = "override property get"         Then MUser(pCount) = w4$ : Incr pCount : Iterate For
      If s123$ = "override property set"         Then MUser(pCount) = w4$ : Incr pCount : Iterate For

      If s1$   = "union"                         Then MUser(pCount) = w2$ : Incr pCount : Iterate For
   Next i

   ReDim Preserve MUser(IIf(pCount>0, pCount-1, pCount))
   Function = Join$(MUser(), $CrLf)
End Function

Sub RemoveComments
   If Debug Then cPrint LCase$(FuncName$)
   Local temp$, i As Long
   Control Get Text hDlg, %IDC_RichEdit To temp$    'put all lines in an array
   Dim D(ParseCount(temp$,$CrLf)-1) As String
   Parse temp$, D(), $CrLf
   For i = 0 To UBound(D)
       D(i) = TrimComments(D(i))   'remove quote and right-side spaces
   Next i
   Control Set Text hDlg, %IDC_RichEdit, Join$(D(),$CrLf)
End Sub

Sub RemoveFTypes
   If Debug Then cPrint LCase$(FuncName$)
   Local temp$, i,iCount As Long
   Control Get Text hDlg, %IDC_RichEdit To temp$    'put all lines in an array
   Dim D(ParseCount(temp$,$CrLf)-1) As String
   Parse temp$, D(), $CrLf
   For i = 0 To UBound(D)
       iCount = InStr(-1,D(i),")")
       If iCount Then D(i) = Left$(D(i),iCount)
   Next i
   Control Set Text hDlg, %IDC_RichEdit, Join$(D(),$CrLf)
End Sub

Function TrimComments(Txt As String) As String
   If Debug Then cPrint LCase$(FuncName$)
   Local i, qFlag As Long, c As String
   For i = 1 To Len(Txt)
      c = Mid$(Txt,i,1)
      If c = $Dq And qFlag = 1 Then
         qFlag = 0
      ElseIf c = $Dq Then
         qFlag = 1
      ElseIf c = "'" And qFlag = 0 Then
         Function = RTrim$(Left$(Txt,i-1))   'found single-quote character not embedded in double-quotes
         Exit Function
      End If
   Next i
   Function = Txt
End Function

Sub RemoveSplits
   If Debug Then cPrint LCase$(FuncName$)
   Local temp$
   Control Get Text hDlg, %IDC_RichEdit To temp$    'put all lines in an array
   Replace " _" + $CrLf With " " In temp$
   Control Set Text hDlg, %IDC_RichEdit, temp$
End Sub

'===Start of Other Context Menu Utilities=======================================================
Function TrimBoth(temp$) As String
   If Debug Then cPrint LCase$(FuncName$)
   Local i As Long
   Dim D(ParseCount(temp$,$CrLf)-1) As String
   Parse temp$, D(), $CrLf
   For i = 0 To UBound(D)
       D(i) = Trim$(D(i))
   Next i
   Function = Join$(D(),$CrLf)
End Function

Function TrimLeft(temp$) As String
   If Debug Then cPrint LCase$(FuncName$)
   Local i As Long
   Dim D(ParseCount(temp$,$CrLf)-1) As String
   Parse temp$, D(), $CrLf
   For i = 0 To UBound(D)
       D(i) = LTrim$(D(i))
   Next i
   Function = Join$(D(),$CrLf)
End Function

Function TrimRight(temp$) As String
   If Debug Then cPrint LCase$(FuncName$)
   Local i As Long
   Dim D(ParseCount(temp$,$CrLf)-1) As String
   Parse temp$, D(), $CrLf
   For i = 0 To UBound(D)
       D(i) = RTrim$(D(i))
   Next i
   Function = Join$(D(),$CrLf)
End Function

Function Insert1Col(temp$) As String
   If Debug Then cPrint LCase$(FuncName$)
   Local i As Long
   Dim D(ParseCount(temp$,$CrLf)-1) As String
   Parse temp$, D(), $CrLf
   For i = 0 To UBound(D)
       D(i) = String$(1," ") + D(i)
   Next i
   Function = Join$(D(),$CrLf)
End Function

Function Delete1Col(temp$) As String
   If Debug Then cPrint LCase$(FuncName$)
   Local i As Long
   Dim D(ParseCount(temp$,$CrLf)-1) As String
   Parse temp$, D(), $CrLf
   For i = 0 To UBound(D)
       D(i) = Mid$(D(i),2)
   Next i
   Function = Join$(D(),$CrLf)
End Function

Function Insert4Col(temp$) As String
   If Debug Then cPrint LCase$(FuncName$)
   Local i As Long
   Dim D(ParseCount(temp$,$CrLf)-1) As String
   Parse temp$, D(), $CrLf
   For i = 0 To UBound(D)
       D(i) = String$(4," ") + D(i)
   Next i
   Function = Join$(D(),$CrLf)
End Function

Function Delete4Col(temp$) As String
   If Debug Then cPrint LCase$(FuncName$)
   Local i As Long
   Dim D(ParseCount(temp$,$CrLf)-1) As String
   Parse temp$, D(), $CrLf
   For i = 0 To UBound(D)
       D(i) = Mid$(D(i),5)
   Next i
   Function = Join$(D(),$CrLf)
End Function

Function RemoveDupeLines(temp$) As String
   If Debug Then cPrint LCase$(FuncName$)
   Local i,iCount As Long, tempold$
   If ExactCaseMatch Then temp$ = LCase$(temp$)
   Dim D(ParseCount(temp$,$CrLf)-1) As String
   Parse temp$, D(), $CrLf

   Array Sort D(), Ascend
   temp$ = "" : tempold$ = Chr$(0)
   For i = 0 To UBound(D)
       D(i) = Trim$(D(i))
       If Len(D(i)) Then
           If D(i) <> tempold$ Then
               temp$ = Build$(temp$, $CrLf, D(i))
               tempold$ = D(i)
               Incr iCount
           End If
       End If
   Next i
   Function = Mid$(temp$,3)
   Statusbar Set Text hDlg, %IDC_Statusbar, 2, 0, Str$(iCount) + " unique lines"
End Function

Function RemoveSpaces(temp$) As String
   If Debug Then cPrint LCase$(FuncName$)
   Local i As Long
   Dim D(ParseCount(temp$,$CrLf)-1) As String
   Parse temp$, D(), $CrLf
   For i = 0 To UBound(D)
      While InStr(D(i), "  ") : Replace "  " With " " In D(i) : Wend       'remove double spaces
   Next i
   Function = Join$(D(),$CrLf)
End Function

Function WordList(temp$) As String
   If Debug Then cPrint LCase$(FuncName$)
   Local i,iCount As Long, tempold$
   Replace $CrLf With " " In temp$
   If ExactCaseMatch = 0 Then temp$ = LCase$(temp$)
   Replace Any BadChar$ With String$(Len(BadChar$)," ") In temp$
   Dim D(ParseCount(temp$,$Spc)-1) As String
   Parse temp$, D(), " "

   Array Sort D(), Ascend
   temp$ = "" : tempold$ = Chr$(0)
   For i = 0 To UBound(D)
       D(i) = Trim$(D(i))
       If Len(D(i)) Then
           If D(i) <> tempold$ Then
               temp$ = Build$(temp$, $CrLf, D(i))
               tempold$ = D(i)
               Incr iCount
           End If
       End If
   Next i
   Function = Mid$(temp$,3)
   Statusbar Set Text hDlg, %IDC_Statusbar, 2, 0, Str$(iCount) + " words found"
End Function

'===Start of Settings Context Menu Utilities=======================================================
Sub ShowCalendarDialog
   If Debug Then cPrint LCase$(FuncName$)
   Local pt As Point, StartDate$
   If OneOnly = 1 Then StartDate$ = DateFromS Else StartDate$ = DateToS
   GetCursorPos pt
   ScreenToClient hDlg, pt
'   Dialog New Pixels, hDlg, "Select Date", pt.x, pt.y, 180, 155, %WS_SysMenu To hCal
    Dialog New Pixels, hDlg, "Select Date", pt.x,pt.y,180,155, %WS_Popup Or _
        %WS_Caption Or %WS_SysMenu Or %WS_ClipSiblings Or %WS_ClipChildren _
        Or %WS_Visible Or %DS_3DLook Or %DS_NoFailCreate Or %DS_SetFont, _
        %WS_Ex_ToolWindow Or %WS_Ex_Left Or %WS_Ex_LtrReading Or _
        %WS_Ex_RightScrollbar, To hCal

   Control Add "SysMonthCal32", hCal, %IDC_Calendar, "", 0,0, 180,155, %WS_Child Or %WS_Visible
   Control Handle hCal, %IDC_Calendar To hCalendar
   Reset DT
   DT.wMonth = Val(Parse$(StartDate$,"-",1))
   DT.wDay   = Val(Parse$(StartDate$,"-",2))
   DT.wYear  = Val(Parse$(StartDate$,"-",3))
   MonthCal_SetCurSel hCalendar, DT
   Control Handle hCal, %IDC_Calendar To hCalendar
   Dialog Show Modal hCal Call CalProc()
End Sub

CallBack Function CalProc() As Long
   Local iResult As Long
   Select Case Cb.Msg
      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDC_Calendar
               Select Case Cb.NmCode
                  Case %MCN_Select
                     iResult = DateTime_GetSystemtime(hCalendar, DT)
                     If OneOnly = 1 Then
                         DateFromS = Format$(DT.wmonth,"00") + "-" + Format$(DT.wday,"00") + "-" +Str$(DT.wyear)
                     Else
                         DateToS   = Format$(DT.wmonth,"00") + "-" + Format$(DT.wday,"00") + "-" +Str$(DT.wyear)
                     End If
                     BuildDateFromDateTo
                     Dialog End hCal
                     OneOnly = 0
               End Select
         End Select
   End Select
End Function

Sub BuildDateFromDateTo
      If Debug Then cPrint LCase$(FuncName$)
      Local ST,STU As SystemTime
      Reset ST
      ST.wMonth = Val(Parse$(DateFromS,"-",1))
      ST.wDay = Val(Parse$(DateFromS,"-",2))
      ST.wYear = Val(Parse$(DateFromS,"-",3))
      TzSpecificLocalTimeToSystemTime ByVal %Null, ST, STU
      SystemTimeToFileTime(STU,DateFrom)
      Reset ST
      ST.wMonth = Val(Parse$(DateToS,"-",1))
      ST.wDay = Val(Parse$(DateToS,"-",2))
      ST.wYear = Val(Parse$(DateToS,"-",3))
      ST.wHour = 23
      ST.wMinute = 59
      ST.wSecond = 59
      TzSpecificLocalTimeToSystemTime ByVal %Null, ST, STU
      SystemTimeToFileTime(STU,DateTo)
End Sub

Function SetSize(Action As String) As Long
    If Debug Then cPrint LCase$(FuncName$)
    Local temp$, x,y As Long
    CenterOverDialog(300,225,x,y)
    Select Case Action
        Case "From"
            temp$ = InputBox$("Enter min file size (KB):","Min File Size",Str$(SizeFrom),x,y)
            If Trim$(temp$) = "" Then temp$ = Str$(SizeFrom)
        Case "To"
            temp$ = InputBox$("Enter max file size (KB):","Max File Size",Str$(SizeTo),x,y)
            If Trim$(temp$) = "" Then temp$ = Str$(SizeTo)
    End Select
    If Val(temp$) < 0 Then temp$ = "0"
    Function = Val(temp$)
End Function

'PBMain + Init_Dialog==========================================================================
Sub BuildExtensionsList
   If Debug Then cPrint LCase$(FuncName$)
    If Len(Dir$(Exe.Path$ + "extensions.txt"))=0 Then
        Open Exe.Path$ + "extensions.txt" For Output As #1
        Print #1, "asm" + $CrLf + "bak" + $CrLf + "bat" + $CrLf + "csv" + $CrLf + "frm" _
                        + $CrLf + "htm" + $CrLf + "ini" + $CrLf + "log" + $CrLf + "pl" + $CrLf + "rc" + $CrLf + "rtf"
        Close #1
    End If
End Sub

Sub BuildAcceleratorTable
   If Debug Then cPrint LCase$(FuncName$)
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(5)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F3 : ac(c).cmd   = %IDM_FindNext    : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_H  : ac(c).cmd   = %IDM_hCommand    : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_D  : ac(c).cmd   = %IDM_PBCodec     : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_L  : ac(c).cmd   = %IDM_PBProcList  : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_R  : ac(c).cmd   = %IDM_ToggleDebug : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_S  : ac(c).cmd   = %IDM_ClearConsole: Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub


Sub CreateImageList
   If Debug Then cPrint LCase$(FuncName$)
    'imagelist for the toolbar
    ImageList New Icon 24,24,32,50 To hImageList
    ImageList Add Icon hImageList, "a"      '1
    ImageList Add Icon hImageList, "about"     '2
    ImageList Add Icon hImageList, "bas"       '3
    ImageList Add Icon hImageList, "exact"     '4
    ImageList Add Icon hImageList, "folder"    '5
    ImageList Add Icon hImageList, "help"      '6
    ImageList Add Icon hImageList, "inc"       '7
    ImageList Add Icon hImageList, "match"     '8
    ImageList Add Icon hImageList, "merge"     '9
    ImageList Add Icon hImageList, "open"      '10
    ImageList Add Icon hImageList, "search"    '11
    ImageList Add Icon hImageList, "find"      '12
    ImageList Add Icon hImageList, "sub"       '13
    ImageList Add Icon hImageList, "txt"       '14
    ImageList Add Icon hImageList, "sign"      '15
    ImageList Add Icon hImageList, "files"     '16
    ImageList Add Icon hImageList, "list"      '17
    ImageList Add Icon hImageList, "view"      '18
    ImageList Add Icon hImageList, "viewtr"     '19
    ImageList Add Icon hImageList, "viewtx"     '20
    ImageList Add Icon hImageList, "folders"    '21
    ImageList Add Icon hImageList, "library"    '22
    ImageList Add Icon hImageList, "settings"   '23
    ImageList Add Icon hImageList, "and"        '24
    ImageList Add Icon hImageList, "or"         '25
    ImageList Add Icon hImageList, "undo"       '26
    ImageList Add Icon hImageList, "gray"       '27
    ImageList Add Icon hImageList, "all"        '28
    ImageList Add Icon hImageList, "calendar"   '29
    ImageList Add Icon hImageList, "size"       '30
    ImageList Add Icon hImageList, "text"       '31

End Sub

Sub CreateContextMenus
   If Debug Then cPrint LCase$(FuncName$)

    'ComboBoxes and TextBoxes
    Menu New PopUp To hContextFolders
    Menu Add String, hContextFolders, "Cut",  %IDM_FolderCut,  %MF_Enabled
    Menu Add String, hContextFolders, "Copy",  %IDM_FolderCopy,  %MF_Enabled
    Menu Add String, hContextFolders, "Paste",  %IDM_FolderPaste,  %MF_Enabled
    Menu Add String, hContextFolders, "Delete",  %IDM_FolderDelete,  %MF_Enabled
    Menu Add String, hContextFolders, "-", %IDM_Sep, 0
    Menu Add String, hContextFolders, "Open Folder",  %IDM_FolderOpen,  %MF_Enabled
    Menu Add String, hContextFolders, "Up One Level",  %IDM_FolderUpOne,  %MF_Enabled
    Menu Add String, hContextFolders, "-", %IDM_Sep, 0
    Menu Add String, hContextFolders, "Clear Folder List",  %IDM_FolderClear,  %MF_Enabled

    Menu New PopUp To hContextTerms
    Menu Add String, hContextTerms, "Cut",  %IDM_TermsCut,  %MF_Enabled
    Menu Add String, hContextTerms, "Copy",  %IDM_TermsCopy,  %MF_Enabled
    Menu Add String, hContextTerms, "Paste",  %IDM_TermsPaste,  %MF_Enabled
    Menu Add String, hContextTerms, "Delete",  %IDM_TermsDelete,  %MF_Enabled
    Menu Add String, hContextTerms, "-", %IDM_Sep, 0
    Menu Add String, hContextTerms, "Clear Search Term List",  %IDM_TermsClear,  %MF_Enabled

    Menu New PopUp To hContextFilters
    Menu Add String, hContextFilters, "Cut",  %IDM_FiltersCut,  %MF_Enabled
    Menu Add String, hContextFilters, "Copy",  %IDM_FiltersCopy,  %MF_Enabled
    Menu Add String, hContextFilters, "Paste",  %IDM_FiltersPaste,  %MF_Enabled
    Menu Add String, hContextFilters, "Delete",  %IDM_FiltersDelete,  %MF_Enabled
    Menu Add String, hContextFilters, "-", %IDM_Sep, 0
    Menu Add String, hContextFilters, "Clear Filter List",  %IDM_FiltersClear,  %MF_Enabled

    'context menu
    Menu New PopUp To hContextListView
    Menu Add String, hContextListView, "Summary",  %IDM_DisplaySummary,  %MF_Enabled
    Menu Add String, hContextListView, "Remove All Items from List",  %IDM_RemoveAllResults,  %MF_Enabled
    Menu Add String, hContextListView, "-", %IDM_Sep, 0
    Menu Add String, hContextListView, "Check All Files",  %IDM_CheckAll,  %MF_Enabled
    Menu Add String, hContextListView, "UnCheck All Files",  %IDM_UnCheckAll,  %MF_Enabled
    Menu Add String, hContextListView, "Reverse Checks",  %IDM_ReverseChecks,  %MF_Enabled
    Menu Add String, hContextListView, "-", %IDM_Sep, 0
    Menu Add String, hContextListView, "Remove Selected File From List",  %IDM_RemoveSelected,  %MF_Enabled
    Menu Add String, hContextListView, "Remove Checked Files From List",  %IDM_RemoveChecked,  %MF_Enabled
    Menu Add String, hContextListView, "Remove UnChecked Files From List",  %IDM_RemoveUnChecked,  %MF_Enabled
    Menu Add String, hContextListView, "-", %IDM_Sep, 0
    Menu Add String, hContextListView, "Delete Selected File From Hard Drive",  %IDM_DeleteSelected,  %MF_Enabled
    Menu Add String, hContextListView, "Delete Checked Files From Hard Drive",  %IDM_DeleteChecked,  %MF_Enabled
    Menu Add String, hContextListView, "-", %IDM_Sep, 0
    Menu Add String, hContextListView, "Use Selection As Base Folder",  %IDM_SetBaseFolder,  %MF_Enabled
    Menu Add String, hContextListView, "Open Folder Containing Selection",  %IDM_OpenFolder,  %MF_Enabled
    Menu Add String, hContextListView, "-", %IDM_Sep, 0
    Menu Add String, hContextListView, "Copy List of Checked Files To Clipboard",  %IDM_CopyList,  %MF_Enabled
    Menu Add String, hContextListView, "Copy Checked Files To Working Folder",  %IDM_CopyChecked,  %MF_Enabled
    Menu Add String, hContextListView, "Open Working Folder",  %IDM_OpenWorking,  %MF_Enabled
    Menu Add String, hContextListView, "Clear Working Folder",  %IDM_ClearWorking,  %MF_Enabled
    Menu Add String, hContextListView, "-", %IDM_Sep, 0
    Menu Add String, hContextListView, "Check For Duplicates of Selected File",  %IDM_CheckDuplicates,  %MF_Enabled
    Menu Add String, hContextListView, "Visually Compare Checked Files",  %IDM_Compare,  %MF_Enabled
    Menu Add String, hContextListView, "-", %IDM_Sep, 0
    Menu Add String, hContextListView, "Open Selected File (Default Client)",  %IDM_OpenExternally,  %MF_Enabled
    Menu Add String, hContextListView, "Open Checked Files (Default Client)",  %IDM_OpenAllDefault,  %MF_Enabled
    Menu Add String, hContextListView, "-", %IDM_Sep, 0
    Menu Add String, hContextListView, "Open Selected File (Specified Client)",  %IDM_OpenSelSpecified,  %MF_Enabled
    Menu Add String, hContextListView, "Open Checked Files (Specified Client)",  %IDM_OpenCheckedSpecified,  %MF_Enabled
    Menu Add String, hContextListView, "Specify Client",  %IDM_SpecifyClient,  %MF_Enabled
    Menu Add String, hContextListView, "-", %IDM_Sep, 0
    Menu Add String, hContextListView, "Export to CSV",  %IDM_ExportCSV,  %MF_Enabled
    Menu Add String, hContextListView, "Export to TXT (Full)",  %IDM_ExportTXT,  %MF_Enabled
    Menu Add String, hContextListView, "Export to TXT (Simple)",  %IDM_ExportTXTB,  %MF_Enabled

    Menu New PopUp To hContextViewer
    Menu Add String, hContextViewer, "Summary",  %IDM_RESummary,  %MF_Enabled
    Menu Add String, hContextViewer, "-", %IDM_Sep, 0
    Menu Add String, hContextViewer, "Cut",  %IDM_RIchEditCut,  %MF_Enabled
    Menu Add String, hContextViewer, "Copy",  %IDM_RichEditCopy,  %MF_Enabled
    Menu Add String, hContextViewer, "Paste",  %IDM_RichEditPaste,  %MF_Enabled
    Menu Add String, hContextViewer, "-", %IDM_Sep, 0
    Menu Add String, hContextViewer, "Delete",  %IDM_RichEditDelete,  %MF_Enabled
    Menu Add String, hContextViewer, "-", %IDM_Sep, 0
    Menu Add String, hContextViewer, "Copy All",  %IDM_CopyAll,  %MF_Enabled
    Menu Add String, hContextViewer, "-", %IDM_Sep, 0
    Menu Add String, hContextViewer, "Find First Matching Line",  %IDM_FindFirst,  %MF_Enabled
    Menu Add String, hContextViewer, "Find Next Matching Line",  %IDM_FindNext,  %MF_Enabled
    Menu Add String, hContextViewer, "Find Previous Matching Line",  %IDM_FindPrevious,  %MF_Enabled
    Menu Add String, hContextViewer, "-", %IDM_Sep, 0
    Menu Add String, hContextViewer, "Next Divider",  %IDM_NextDivider,  %MF_Enabled
    Menu Add String, hContextViewer, "Previous Divider",  %IDM_PreviousDivider,  %MF_Enabled
    Menu Add String, hContextViewer, "Open File Containing Current Line",  %IDM_OpenDivider,  %MF_Enabled
    Menu Add String, hContextViewer, "-", %IDM_Sep, 0
    Menu Add String, hContextViewer, "Highlight Terms",  %IDM_HighlightTerms,  %MF_Enabled
    Menu Add String, hContextViewer, "Remove Highlighting",  %IDM_UnHighlightTerms,  %MF_Enabled
    Menu Add String, hContextViewer, "-", %IDM_Sep, 0
    Menu Add String, hContextViewer, "Show Matching Lines Only",  %IDM_MatchingLinesOnly,  %MF_Enabled
    Menu Add String, hContextViewer, "-", %IDM_Sep, 0
    Menu Add String, hContextViewer, "Sort Content Ascending",  %IDM_SortContentA,  %MF_Enabled
    Menu Add String, hContextViewer, "Sort Content Descending",  %IDM_SortContentD,  %MF_Enabled
    Menu Add String, hContextViewer, "-", %IDM_Sep, 0
    Menu Add String, hContextViewer, "Save Content As Selected File Name",  %IDM_RichEditSave,  %MF_Enabled
    Menu Add String, hContextViewer, "Save Content As ...",  %IDM_RichEditSaveAs,  %MF_Enabled
    Menu Add String, hContextViewer, "-", %IDM_Sep, 0
    Menu Add String, hContextViewer, "Reload Merge File",  %IDM_ReloadMergeFile,  %MF_Enabled
    Menu Add String, hContextViewer, "Open Merge File (Default Client)",  %IDM_OpenMergeFile,  %MF_Enabled
    Menu Add String, hContextViewer, "-", %IDM_Sep, 0
    Menu Add String, hContextViewer, "Add Line Numbers",  %IDM_AddLineNumbers,  %MF_Enabled
    Menu Add String, hContextViewer, "Remove Line Numbers",  %IDM_RemoveLineNumbers,  %MF_Enabled
    Menu Add String, hContextViewer, "-", %IDM_Sep, 0
    Menu Add String, hContextViewer, "Remove Dividers",  %IDM_RemoveDividers,  %MF_Enabled
    Menu Add String, hContextViewer, "Remove Blank Lines",  %IDM_RemoveBlankLines,  %MF_Enabled
    Menu Add String, hContextViewer, "Remove Extra Spaces",  %IDM_RemoveSpaces,  %MF_Enabled
    Menu Add String, hContextViewer, "-", %IDM_Sep, 0
    Menu Add String, hContextViewer, "Upper Case",  %IDM_UpperCase,  %MF_Enabled
    Menu Add String, hContextViewer, "Lower Case",  %IDM_LowerCase,  %MF_Enabled
    Menu Add String, hContextViewer, "-", %IDM_Sep, 0
    Menu Add String, hContextViewer, "Trim Right/Left",  %IDM_TrimBoth,  %MF_Enabled
    Menu Add String, hContextViewer, "Trim Left",  %IDM_TrimLeft,  %MF_Enabled
    Menu Add String, hContextViewer, "Trim Right",  %IDM_TrimRight,  %MF_Enabled
    Menu Add String, hContextViewer, "-", %IDM_Sep, 0
    Menu Add String, hContextViewer, "Insert 1 Column (Left Margin)",  %IDM_Insert1Col,  %MF_Enabled
    Menu Add String, hContextViewer, "Delete 1 Column (Left Margin)",  %IDM_Delete1Col,  %MF_Enabled
    Menu Add String, hContextViewer, "-", %IDM_Sep, 0
    Menu Add String, hContextViewer, "Insert 4 Columns (Left Margin)",  %IDM_Insert4Col,  %MF_Enabled
    Menu Add String, hContextViewer, "Delete 4 Columns (Left Margin)",  %IDM_Delete4Col,  %MF_Enabled
    Menu Add String, hContextViewer, "-", %IDM_Sep, 0
    Menu Add String, hContextViewer, "Unique Lines (Sorted)",  %IDM_RemoveDupeLines,  %MF_Enabled
    Menu Add String, hContextViewer, "Word List",  %IDM_WordList,  %MF_Enabled
End Sub

Sub CreateToolbarContextMenu
    If Debug Then cPrint LCase$(FuncName$)
    Local temp$, i As Long
    'List dropdown
    Menu New PopUp To hExtList
    Open Exe.Path$ + "extensions.txt" For Binary As #1 : Get$ #1, Lof(1), temp$ : Close #1
    Menu Add String, hExtList, "... Edit List", %IDM_ExtList,  %MF_Enabled
    For i = 1 To ParseCount(temp$,$CrLf)
       Menu Add String, hExtList, Trim$(Parse$(temp$,$CrLf,i)), %IDM_ExtList + 1,  %MF_Enabled
    Next i

    'Merge dropdown
    Menu New PopUp To hMerge
    Menu Add String, hMerge, "Create gbSnippets Library",  %IDM_gbSnippets,  %MF_Enabled

    'Date dropdown
    Menu New PopUp To hDate
    Menu Add String, hDate, "From: ",  %IDM_DateFrom,  %MF_Enabled
    Menu Add String, hDate, "To: ",  %IDM_DateTo,  %MF_Enabled
    Menu Add String, hDate, "Reset Dates",  %IDM_ResetDates,  %MF_Enabled

    'Size dropdown
    Menu New PopUp To hSize
    Menu Add String, hSize, "From: ",  %IDM_SizeFrom,  %MF_Enabled
    Menu Add String, hSize, "To: ",  %IDM_SizeTo,  %MF_Enabled

    'Terms dropdown
    Menu New PopUp To hTerms
    Menu Add String, hTerms, "All Terms",  %IDM_Any,  %MF_Enabled
    Menu Add String, hTerms, "Any Term",  %IDM_All,  %MF_Enabled
    Menu Add String, hTerms, "Complete String",  %IDM_Exact,  %MF_Enabled

    'Setting dropdown
    Menu New PopUp To hSettings
    Menu Add String, hSettings, "Display Toolbar Text",  %IDM_ToolbarText,  %MF_Enabled
    Menu Add String, hSettings, "-", %IDM_Sep, 0
    Menu Add String, hSettings, "Exact File Size",  %IDM_ExactFileSize,  %MF_Enabled
    Menu Add String, hSettings, "-", %IDM_Sep, 0
    Menu Add String, hSettings, "Colored Lines",  %IDM_ColoredLines,  %MF_Enabled
    Menu Add String, hSettings, "Select Line Color",  %IDM_LineColor,  %MF_Enabled
    Menu Add String, hSettings, "-", %IDM_Sep, 0
    Menu Add String, hSettings, "AutoSize to Dialog Width",  %IDM_AutoSizeToWidth,  %MF_Enabled
    Menu Add String, hSettings, "AutoSize to Data",  %IDM_AutoSizeToData,  %MF_Enabled
    Menu Add String, hSettings, "AutoSize Disabled",  %IDM_AutoSizeToNone,  %MF_Enabled
    Menu Add String, hSettings, "-", %IDM_Sep, 0
    Menu Add String, hSettings, "Line Numbers",  %IDM_LineNumbers,  %MF_Enabled
    Menu Add String, hSettings, "Dividers",  %IDM_Dividers,  %MF_Enabled
    Menu Add String, hSettings, "Auto Open",  %IDM_AutoOpenMerge,  %MF_Enabled
    Menu Add String, hSettings, "-", %IDM_Sep, 0
    Menu Add String, hSettings, "Include Hidden/System Files",  %IDM_HiddenSystem,  %MF_Enabled
    Menu Add String, hSettings, "Unrestricted Search",  %IDM_Unrestricted,  %MF_Enabled
    Menu Add String, hSettings, "Implied Search",  %IDM_ImpliedSearch,  %MF_Enabled
    Menu Add String, hSettings, "-", %IDM_Sep, 0
    Menu Add String, hSettings, "Allow File Deletion",  %IDM_AllowFileDeletion,  %MF_Enabled
End Sub

Sub SubClassControls
   If Debug Then cPrint LCase$(FuncName$)
   Local ComboInfo As ComboBoxInfo
   ComboInfo.cbSize = SizeOf(ComboBoxInfo)

   GetComboBoxInfo(hComboFilters, ByVal VarPtr(ComboInfo))          'get data about combobox
   hComboFiltersEdit = ComboInfo.hwndItem                           'handle to edit control of combobox
   OldComboFiltersEditProc& = SetWindowLong(hComboFiltersEdit, %GWL_WndProc, CodePtr(NewComboFiltersEditProc))   'subclass a control

   GetComboBoxInfo(hComboTerms, ByVal VarPtr(ComboInfo))          'get data about combobox
   hComboTermsEdit = ComboInfo.hwndItem                           'handle to edit control of combobox
   OldComboTermsEditProc& = SetWindowLong(hComboTermsEdit, %GWL_WndProc, CodePtr(NewComboTermsEditProc))   'subclass a control

   GetComboBoxInfo(hComboFolders, ByVal VarPtr(ComboInfo))          'get data about combobox
   hComboFoldersEdit = ComboInfo.hwndItem                           'handle to edit control of combobox
   OldComboFoldersEditProc& = SetWindowLong(hComboFoldersEdit, %GWL_WndProc, CodePtr(NewComboFoldersEditProc))   'subclass a control
End Sub

Sub CreateToolbar
   If Debug Then cPrint LCase$(FuncName$)
    'toolbar
    Local hTips As Dword, w,h As Long
    Dialog Get Client hDlg To w,h
    Control Kill hDlg, %IDC_Toolbar  'if it already existed, then KILL it
    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    hTips = SendMessage(GetDlgItem(hDlg, %IDC_Toolbar), %TB_GETTOOLTIPS, 0, 0)
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS
    SetWindowLong hTips, %GWL_STYLE, GetWindowLong(hTips, %GWL_STYLE) Or %TTS_ALWAYSTIP

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0    'attach imagelist
    Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_SelectFolder,  %TbStyle_Button, Choose$(ToolbarText, "Folder")
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 11, %IDT_Search,  %TbStyle_Button, Choose$(ToolbarText, "Search")
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 15, %IDT_MergeFiles,  %TbStyle_Button Or %TbStyle_DropDown, Choose$(ToolbarText, "Merge")
    Toolbar Add Button  hDlg, %IDC_Toolbar, 26, %IDT_Undo,  %TbStyle_Button, Choose$(ToolbarText, "Undo")
       Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Undo, %TBState_Disabled
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 13, %IDT_ViewTree,  %TbStyle_Check Or %TbStyle_DropDown, Choose$(ToolbarText, "Explorer")
    Toolbar Add Button  hDlg, %IDC_Toolbar, 18, %IDT_ViewFile,  %TbStyle_Check, Choose$(ToolbarText, "Viewer")

    If Unrestricted = 0 Then
        Toolbar Add Separator hDlg, %IDC_Toolbar, 20
        Toolbar Add Button  hDlg, %IDC_Toolbar, 28, %IDT_CheckAll,   %TbStyle_Check, Choose$(ToolbarText, "All")
        Toolbar Add Separator hDlg, %IDC_Toolbar, 20
        Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_CheckBas,   %TbStyle_Check, Choose$(ToolbarText, ".bas")
        Toolbar Add Button  hDlg, %IDC_Toolbar, 7, %IDT_CheckInc,   %TbStyle_Check, Choose$(ToolbarText, ".inc")
        Toolbar Add Button  hDlg, %IDC_Toolbar, 14, %IDT_CheckTxt,   %TbStyle_Check, Choose$(ToolbarText, ".txt")
        Toolbar Add Button  hDlg, %IDC_Toolbar, 17, %IDT_CheckList,   %TbStyle_Check Or %TbStyle_DropDown, Choose$(ToolbarText, "List")
    End If

    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 29, %IDT_Date,  %TbStyle_Check Or %TbStyle_DropDown, Choose$(ToolbarText, "Date")
    Toolbar Add Button  hDlg, %IDC_Toolbar, 30, %IDT_Size,  %TbStyle_Check Or %TbStyle_DropDown, Choose$(ToolbarText, "Size")
    Toolbar Add Button  hDlg, %IDC_Toolbar, 31, %IDT_Terms,  %TbStyle_Check Or %TbStyle_DropDown, Choose$(ToolbarText, "Terms")
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button  hDlg, %IDC_Toolbar, 21, %IDT_SubFolders,  %TbStyle_Check, Choose$(ToolbarText, "SubFolders")
    Toolbar Add Button  hDlg, %IDC_Toolbar, 8, %IDT_ExactCaseMatch,  %TbStyle_Check, Choose$(ToolbarText, "Match Case")
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20

    Toolbar Add Button  hDlg, %IDC_Toolbar, 23, %IDT_Settings,  %TbStyle_Button Or %TbStyle_DropDown, Choose$(ToolbarText, "Settings")
    Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_Help,  %TbStyle_Button, Choose$(ToolbarText, "Help")

    SetToolbarMenuStatus
End Sub


'Chevron Functions=========================================================================
Sub OpenDivider
   If Debug Then cPrint LCase$(FuncName$)
   Local iStartLine, iStartPos, iLengthText, iResult As Long, buf$, tempZ As AsciiZ * %Max_Path

   iStartLine = SendMessage(hRichEdit, %EM_EXLineFromChar, 0, -1)         'current line# or 1st line# of selection
   iStartPos = SendMessage(hRichEdit, %EM_EXLineFromChar, 0, iStartLine)  '1st char of current line
   iLengthText = SendMessage(hRichEdit, %EM_LineLength, iStartPos, 0)     'length of current line
   buf$ = Space$(iLengthText)
   SendMessage(hRichEdit, %EM_GetLine, iStartLine&, StrPtr(buf$))          'entire line of text

   If Left$(buf$,6) <> CustomDivider Then
       bFindDividerInRichEdit(0)  'go back to next divider
       iStartLine = SendMessage(hRichEdit, %EM_EXLineFromChar, 0, -1)         'current line# or 1st line# of selection
       iStartPos = SendMessage(hRichEdit, %EM_EXLineFromChar, 0, iStartLine)  '1st char of current line
       iLengthText = SendMessage(hRichEdit, %EM_LineLength, iStartPos, 0)     'length of current line
       buf$ = Space$(iLengthText)
       SendMessage(hRichEdit, %EM_GetLine, iStartLine&, StrPtr(buf$))         'entire line of text
   End If
   tempZ = Trim$(Parse$(buf$,CustomDivider,2))
   iResult = ShellExecute(hDlg, "Open", tempZ, $Nul, $Nul, %SW_ShowNormal)
End Sub

Sub bFindDividerinRichEdit(iDirection&)  'SearchTerm$ are global, iDirection& = 1 for forward, =0 for backward
   If Debug Then cPrint LCase$(FuncName$)
   Local temp$, P As CharRange, SearchStart&, i,LTerm,iStart,iFlag As Long

   sTerm = CustomDivider

   Control Get Text hDlg, %IDC_RichEdit To temp$                   'get text from RichEdit
   Control Send hDlg, %IDC_RichEdit, %EM_ExGetSel, 0, VarPtr(P)    'get caret/selection boundaries

   ReDim T(0)
   T(0) = sTerm

   If (iDirection& = 0) And (P.cpmin = Len(temp$)) Then P.cpmin = P.cpmin - 1

   'highlight first found term
   If iDirection& Then SearchStart& = Len(temp$) Else SearchStart& = 0
   iFlag = 0
   For i = 0 To UBound(T)
      iStart = InStr(IIf(iDirection&, P.cpMax+1, -1*(Len(temp$)-P.cpMin)-1), temp$, T(i))
      If iStart Then
         If iDirection& Then
            If iStart < SearchStart& Then SearchStart& = iStart : LTerm = Len(T(i)) : iFlag = 1
         Else
            If iStart > SearchStart& Then SearchStart& = iStart : LTerm = Len(T(i)) : iFlag = 1
         End If
      End If
   Next i
   If iFlag Then
      P.cpMin = SearchStart& - 1
      P.cpMax = SearchStart& + LTerm - 1
      Control Send hDlg, %IDC_RichEdit, %EM_ExSetSel, 0, VarPtr(P)
   Else
      Beep
   End If
End Sub


Sub bFindTextinRichEdit(iDirection&)  'SearchTerm$ are global, iDirection& = 1 for forward, =0 for backward
   If Debug Then cPrint LCase$(FuncName$)
   Local temp$, P As CharRange, SearchStart&, i,LTerm,iStart,iFlag As Long
   Control Get Text hDlg, %IDC_ComboTerms To sTerm

   If Len(Trim$(sTerm)) = 0 Then Beep : Exit Sub

   Control Get Text hDlg, %IDC_RichEdit To temp$                   'get text from RichEdit
   Control Send hDlg, %IDC_RichEdit, %EM_ExGetSel, 0, VarPtr(P)    'get caret/selection boundaries

   If ExactCaseMatch = 0 Then temp$ = LCase$(temp$)                    'upper/lower case as appropriate
   CreateSearchTermArray                                           'determine bMethod$, fill T()
   If (iDirection& = 0) And (P.cpmin = Len(temp$)) Then P.cpmin = P.cpmin - 1

   'highlight first found term
   If iDirection& Then SearchStart& = Len(temp$) Else SearchStart& = 0
   iFlag = 0
   For i = 0 To UBound(T)
      iStart = InStr(IIf(iDirection&, P.cpMax+1, -1*(Len(temp$)-P.cpMin)-1), temp$, T(i))
      If iStart Then
         If iDirection& Then
            If iStart < SearchStart& Then SearchStart& = iStart : LTerm = Len(T(i)) : iFlag = 1
         Else
            If iStart > SearchStart& Then SearchStart& = iStart : LTerm = Len(T(i)) : iFlag = 1
         End If
      End If
   Next i
   If iFlag Then
      P.cpMin = SearchStart& - 1
      P.cpMax = SearchStart& + LTerm - 1
      Control Send hDlg, %IDC_RichEdit, %EM_ExSetSel, 0, VarPtr(P)
   Else
      Beep
   End If
End Sub

Sub DrawChevron
    If Debug Then cPrint LCase$(FuncName$)
    Local P As PolyPoints
    'up chevron
    P.count = 3
    P.x1 = 4 : P.y1 = 0
    P.x2 = 0 : P.y2 = 12
    P.x3 = 8 : P.y3 = 12
    If ChevronColor = 1 Then
       Graphic Polygon P, %Red, %rgb_Gray
    Else
       Graphic Polygon P, %rgb_DarkSlateGray, %rgb_DarkSlateGray
    End If

    'down chevron
    P.x1 = 4 : P.y1 = 28
    P.x2 = 0 : P.y2 = 16
    P.x3 = 8 : P.y3 = 16
    If ChevronColor = 2 Then
        Graphic Polygon P, %Red, %rgb_Gray
    Else
       Graphic Polygon P, %rgb_DarkSlateGray, %rgb_DarkSlateGray
    End If

    'highlight terms
    If ChevronColor = 3 Then
        Graphic Line (0,39)-(9,39), %Gray
        Graphic Line (4,35)-(4,44), %Gray
        Graphic Ellipse (2,37)-(7,42), 0,%Red,%Red
    Else
        Graphic Line (0,39)-(9,39), %Black
        Graphic Line (4,35)-(4,44), %Black
        Graphic Ellipse (2,37)-(7,42), 0,%Yellow,%Yellow
    End If

    'limit lines
    If ChevronColor = 4 Then
        Graphic Line (0,51)-(9,51), %Red
        Graphic Line (0,53)-(9,53), %Red
        Graphic Line (0,55)-(9,55), %Red
    Else
        Graphic Line (0,51)-(9,51), %Black
        Graphic Line (0,53)-(9,53), %Black
        Graphic Line (0,55)-(9,55), %Black
    End If


End Sub

'Select/LoadFile =========================================================================
Sub SelectFile
   If Debug Then cPrint LCase$(FuncName$)
   Local i,iCount As Long, temp$
   ListView Get Count hDlg, %IDC_ListView To iCount
   If iCount = 0 Then Exit Sub
   For i = 1 To iCount
      ListView Get Text hDlg, %IDC_ListView, i,2 To temp$
      If SelectedFile = temp$ Then
          ListView Select hDlg, %IDC_ListView, i
          Exit Sub
      End If
   Next i
End Sub

Sub LoadSelectedFile
   If Debug Then cPrint LCase$(FuncName$)

   If InStr(TextExt, PathName$(Extn,SelectedFile)) = 0 Then
       Control Set Text hDlg, %IDC_RichEdit, "<not recognized as text file>"
       Dialog Set Text hDlg, $Ver + "   " + SelectedFile
       Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, "<not recognized as text file>"
       Exit Sub
   End If

   Local temp$
   SetUndo("",0)
    If Len(Dir$(SelectedFile))=0 Or Len(SelectedFile)=0 Then Exit Sub
    Open SelectedFile For Binary As #1
    Get$ #1, Lof(1), temp$
    Close #1
    Control Set Text hDlg, %IDC_RichEdit, ""
    StrikeOutSetRichTextColor %Black             'to undo results of previous strikeout coloring
    Control Set Text hDlg, %IDC_RichEdit, temp$
    Dialog Set Text hDlg, $Ver + "   " + SelectedFile
    Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, "  Lines: " + Format$(ParseCount(temp$,$CrLf),"###,###,###") + "     Chars: " + Format$(Len(temp$),"###,###,###")
End Sub

'ComboBox Functions  ===========================================================================
Sub LoadFoldersComboBox
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long
    'rebuild ComboBox of folders
    ComboBox Reset hDlg, %IDC_ComboFolders
    For i = UBound(folderMRU) To 0 Step -1
        If Len(folderMRU(i)) Then ComboBox Insert hDlg, %IDC_ComboFolders, 1, folderMRU(i)
    Next i
    ComboBox Select hDlg, %IDC_ComboFolders, 1
End Sub

Sub AddToFolderMRU
   If Debug Then cPrint LCase$(FuncName$)
    'sFolder will be placed at top of array. duplicate, if exists, will be removed
    Local i, Flag As Long, temp$
    temp$ = RTrim$(sFolder,"\")
    If Right$(temp$,1) = ":" Then temp$ = temp$ + "\"

   'is sFolder in stermMRU() ?
    For i = 0 To UBound(folderMRU)
        If folderMRU(i) = temp$ Then
            Array Delete folderMRU(i)
            Array Insert folderMRU(0), temp$
            Flag = 1
            Exit Sub
        End If
    Next i
    'add sFolder to list, if not already in the list
    If Flag = 0 Then Array Insert folderMRU(0), temp$
End Sub

Sub LoadSearchTermsCombobox
   If Debug Then cPrint LCase$(FuncName$)
    Local i As Long
    'rebuild ComboBox of sTerms
    ComboBox Reset hDlg, %IDC_ComboTerms
    For i = UBound(stermMRU) To 0 Step - 1
       If Len(stermMRU(i)) Then ComboBox Insert hDlg, %IDC_ComboTerms, 1, stermMRU(i)
    Next i
    ComboBox Select hDlg, %IDC_ComboTerms, 1
End Sub

Sub AddToSearchTermMRU
    If Debug Then cPrint LCase$(FuncName$)
    'sTerm will be placed at top of array. duplicate, if exists, will be removed
    Local i, Flag As Long
    'is sTerm in stermMRU() ?
    For i = 0 To UBound(stermMRU)
        If stermMRU(i) = sTerm Then
            Array Delete stermMRU(i)
            Array Insert stermMRU(0), sTerm
            Flag = 1
            Exit Sub
        End If
    Next i
    'add sTerm to list, if not already in the list
    If Flag = 0 Then Array Insert stermMRU(0), sTerm
End Sub

Sub LoadFileFiltersComboBox
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long
    'rebuild ComboBox of file filters
    ComboBox Reset hDlg, %IDC_ComboFilters
    For i = UBound(filterMRU) To 0 Step -1
        If Len(filterMRU(i)) Then ComboBox Insert hDlg, %IDC_ComboFilters, 1, filterMRU(i)
    Next i
    ComboBox Select hDlg, %IDC_ComboFilters, 1
End Sub

Sub AddToFileFilterMRU
    If Debug Then cPrint LCase$(FuncName$)
    'FileFilter will be placed at top of array. duplicate, if exists, will be removed
    Local i, Flag As Long
    'is FileFilter in filterMRU() ?
    For i = 0 To UBound(filterMRU)
        If filterMRU(i) = FileFilter Then
            Array Delete filterMRU(i)
            Array Insert filterMRU(0), FileFilter
            Flag = 1
            Exit Sub
        End If
    Next i
    'add FileFilter to list, if not already in the list
    If Flag = 0 Then Array Insert filterMRU(0), FileFilter
End Sub

Function NewComboFiltersEditProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Select Case Msg
      Case %WM_ContextMenu
         TrackPopupMenu hContextFilters, %TPM_LeftAlign,Lo(Integer,LParam),Hi(Integer, LParam), 0, hDlg, ByVal 0
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldComboFiltersEditProc&, hWnd, Msg, wParam, lParam)   'send unprocessed messages to the original procedure
End Function

Function NewComboTermsEditProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Static xold,yold As Long
   Select Case Msg
      Case %WM_SetFocus
         xterms = xold : yterms = yold
      Case %WM_KillFocus
         SendMessage hWnd, %EM_GetSel, VarPtr(xold), VarPtr(yold)
         xterms=0 : yterms = 0
      Case %EM_SetSel
         wParam = xterms: lParam = yterms
      Case %WM_KeyUp, %WM_LButtonUp
         SendMessage hWnd, %EM_GetSel, VarPtr(xold), VarPtr(yold)
      Case %WM_ContextMenu
         TrackPopupMenu hContextTerms, %TPM_LeftAlign, Lo(Integer,LParam), Hi(Integer,LParam), 0, hDlg, ByVal 0
         Function = 0 : Exit Function    'use if no further message processing is required
   End Select
   Function = CallWindowProc(OldComboTermsEditProc, hWnd, Msg, wParam, lParam)   'send unprocessed messages to the original procedure
End Function

Function NewComboFoldersEditProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Static xold,yold As Long
   Select Case Msg
      Case %WM_SetFocus
         xfolders = xold : yfolders = yold
      Case %WM_KillFocus
         SendMessage hWnd, %EM_GetSel, VarPtr(xold), VarPtr(yold)
         xfolders=0 : yfolders = 0
      Case %EM_SetSel
         wParam = xfolders: lParam = yfolders
      Case %WM_KeyUp, %WM_LButtonUp
         SendMessage hWnd, %EM_GetSel, VarPtr(xold), VarPtr(yold)
      Case %WM_ContextMenu
         TrackPopupMenu hContextFolders, %TPM_LeftAlign, Lo(Integer,LParam), Hi(Integer,LParam), 0, hDlg, ByVal 0
         Function = 0 : Exit Function    'use if no further message processing is required
   End Select
   Function = CallWindowProc(OldComboFoldersEditProc, hWnd, Msg, wParam, lParam)   'send unprocessed messages to the original procedure
End Function

'hCommand Functions==========================================================================
Sub ShowPathInTree
    If Debug Then cPrint LCase$(FuncName$)
    Local iLevel As Long, hNode As Dword, temppath$, Path$, temp$

    ComboBox Get Text hDlg, %IDC_ComboFolders To sFolder
    sFolder = RTrim$(sFolder,"\")

    Treeview Get Root hDlg, %IDC_TreeView To hNode
    Treeview Get Text hDlg, %IDC_TreeView, hNode To Path$
    Incr iLevel

    While Path$ <> sFolder
        DisplayChildren(hNode)
        Incr iLevel
        Treeview Get Child hDlg, %IDC_TreeView, hNode To hNode
        Treeview Get Text hDlg, %IDC_TreeView, hNode To temp$
        temppath$ = Path$ + "\" + temp$ + "\"
        While temppath$ <> sFolderLevel(iLevel)
            Treeview Get Next hDlg, %IDC_TreeView, hNode To hNode
            If hNode = 0 Then Exit Do
            Treeview Get Text hDlg, %IDC_TreeView, hNode To temp$
            temppath$ = Path$ + "\" + temp$ + "\"
        Wend
        If temppath$ = sFolder Then Path$ = temppath$
        If iLevel > 3 Then ? "too many levels" : Exit Do
    Wend

    Treeview Select hDlg, %IDC_TreeView, hNode
End Sub

Function sFolderLevel(n As Long) As String
    If Debug Then cPrint LCase$(FuncName$)
    Local i,iPos As Long
    For i = 1 To n
        iPos = InStr(iPos,sFolder,"\")
    Next i
    Function = Left$(sFolder,iPos)
End Function

Sub hCommand
    ? "Nothing here right now!"
End Sub

Sub UpdateTextExt
   If Debug Then cPrint LCase$(FuncName$)
   Local temp$
   TextExt = ".bas .inc .txt "
   Open Exe.Path$ + "extensions.txt" For Input As #1
   While IsFalse(Eof(1))
       Line Input #1, temp$
       If Len(Trim$(temp$)) Then
           TextExt = TextExt + " ." + temp$
       End If
   Wend
   Close #1
End Sub

Sub ClearStatusBarIfListViewEmpty
   If Debug Then cPrint LCase$(FuncName$)
   Local iResult As Long
   ListView Get Count hDlg, %IDC_ListView To iResult
   If iResult = 0 Then
      Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, ""
      Statusbar Set Text hDlg, %IDC_Statusbar, 2, 0, ""
      Control Set Text hDlg, %IDC_RichEdit, ""
   End If
End Sub

Sub AdjustSizeDisplay
   If Debug Then cPrint LCase$(FuncName$)
   Local iFileSize As Quad
   Local i,iCount As Long, temp$, FData As DirData
   ListView Get Count hDlg, %IDC_ListView To iCount
   If iCount = 0 Then Exit Sub
   MousePtr 11
   For i = 1 To iCount
      ListView Get Text hDlg, %IDC_ListView, i,2 To temp$
      temp$ = Dir$(temp$ To FData)
      iFileSize = FData.FileSizeHigh * &H100000000 + FData.FileSizeLow
      If ExactFileSize Then
          ListView Set Text hDlg, %IDC_ListView, i,4, Format$(iFileSize,"#,###,###,###") ' + "    "
      Else
          If iFileSize < 1024 Then iFileSize = 1024
          ListView Set Text hDlg, %IDC_ListView, i,4, Format$(iFileSize/1024,"#,###,###") ' + "    "
      End If
   Next i
   MousePtr 1
End Sub

Sub RemoveSizeCommas
   If Debug Then cPrint LCase$(FuncName$)
   Local i,iCount As Long, temp$
   ListView Get Count hDlg, %IDC_ListView To iCount
   If iCount = 0 Then Exit Sub
   MousePtr 11
   For i = 1 To iCount
      ListView Get Text hDlg, %IDC_ListView, i,4 To temp$
      Replace "," With "" In temp$
      ListView Set Text hDlg, %IDC_ListView, i,4, temp$
   Next i
   MousePtr 1
End Sub
